<?php

/**
 *
 * web-GFC configuration file
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
/**
 * Configuration GEDOOo
 */
Configure::write('PROTOCOLE_DL', 'vnd.sun.star.webdav');
Configure::write('GENERER_DOC_SIMPLE', false);
Configure::write('USE_GEDOOO', true);
//Configure::write('GEDOOO_WSDL', 'http://gedooo.test.adullact.org:8980/ODFgedooo/OfficeService?wsdl');
Configure::write('GEDOOO_WSDL', 'http://192.168.2.35:8880/ODFgedooo-0.8.05/OfficeService?wsdl');

/**
 * Configuration cloudooo
 */
/* Configuration pour la conversion de format des documents */
Configure::write('CLOUDOOO_HOST', '192.168.2.35');
Configure::write('CLOUDOOO_PORT', '8011'); //par défaut: 8011


/**
 * Configuration scan
 */
Configure::write('scan.remote.ftp', false);
Configure::write('scan.remote.ssh', false);
Configure::write('scan.remote.smb', false);
Configure::write('scan.imap', false);


/**
 * Configuration de la détection de terme similaire (contacts)
 */
Configure::write('levenshteinThreshold', 4);

/**
 * Configuration de la valeur du champ de type select dans les métadonnées
 * @param: integer id
 */
Configure::write('Selectvaluemetadonnee.id', 4);


/** Configuration du connecteur avec le i-parpaheur * */
/**
 * Parapheur (Signature électronique, délégation)
 */
/* Activer le parapheur */
Configure::write('USE_PARAPHEUR', true);
/* Service utilisé pour le parapheur ('PASTELL', 'IPARAPHEUR', ...) */
Configure::write('PARAPHEUR', 'IPARAPHEUR');


/* Configuration Webservice du i-Parapheur */
/* Configure::write('USE_IPARAPHEUR', true);
  Configure::write('IPARAPHEUR_HOST', 'https://secure-parapheur.test.adullact.org');
  Configure::write('IPARAPHEUR_LOGIN', 'webgfc');
  Configure::write('IPARAPHEUR_PWD', 'webgfc');
  Configure::write('IPARAPHEUR_TYPE', 'Courriers');
  Configure::write('IPARAPHEUR_VISIBILITY', 'PUBLIC'); // CONFIDENTIEL pour Angoulême
  Configure::write('IPARAPHEUR_WSDL', 'ws-iparapheur');
  Configure::write('IPARAPHEUR_CACERT', APP . 'Config/cert_parapheur/ac.pem');
  Configure::write('IPARAPHEUR_CLIENTCERT', APP . 'Config/cert_parapheur/cert.pem');
  Configure::write('IPARAPHEUR_CERT', 'demou.p12');
  Configure::write('IPARAPHEUR_CERTPWD', 'demou'); */

/* Nom du client webgfc */
Configure::write('WEBGFCCLIENT', 'VILLE DE BARLEDUC');

/* Utilisation des notificatons ou non */
Configure::write('SMTP_USE', false);

/* URL de Webgfc (pour mails) */
Configure::write('WEBGFC_URL', 'https://webgfc17.webgfc.fr');

/* Affichage ou non du bloc Document disponibles pour insérer dans le modèle (flux sortant) */
// false = angouleme
Configure::write('DOC_DEFAULT', true);

/**
 * GED (Gestion électronique documentaire)
 */
/* Activer la GED */
Configure::write('Parapheur.id', 1);
Configure::write('Ged.id', 2);
Configure::write('USE_GED', false);
/* Service utilisé pour la GED ('PASTELL' ou 'GED') */
Configure::write('GED', 'CMIS');
//Configure::write('GED_XML_VERSION', '3');

/* Configuration CONNECTEUR CMIS GED */
//Configure::write('CMIS_HOST', 'http://cmis.test.adullact.org/alfresco/service/cmis');
//Configure::write('CMIS_LOGIN', 'webgfc');
//Configure::write('CMIS_PWD', 'webgfc');
//Configure::write('CMIS_REPO', '/Sites/web-gfc');

/* Suite au ticket 9380, mise en condition de l'affichage des onglets Accusé de réception et Composants de réponse */
/* Utilisé aussi pour l'envoi à la signature manuelle */
//false = bar le duc
Configure::write('DOC_FROM_GFC', true);

/* Désactivation de la possibilité d'ajouter des profils perosnnalisés */
// true = angouleme
Configure::write('ProfilPerso.actif', true);
Configure::write('Impression.PDFvalue', '"iParapheur_impression_dossier.pdf"');

/* Configuration par boîte mail utilisant du IMAP */
Configure::write('Conf.Imap', '/novalidate-cert');

Configure::write('PRODUIT', 'web-GFC');

/* Ajout pour les cas où les utilisateurs souhaitent que les flux en copie soient modifiables */
Configure::write('Copie.modified', false);
Configure::write('Sansorganisme.id', 656);


Configure::write('CONVERSION_TYPE', 'CLOUDOOO');


/* * ** Configuration CAS **** */
Configure::write('AuthManager.Authentification.use', false);
Configure::write('AuthManager.Authentification.type', '');

Configure::write('AuthManager.Cas.host', 'auth.webgfc.fr');
Configure::write('AuthManager.Cas.port', '443');
Configure::write('AuthManager.Cas.uri', '/cas');
Configure::write('AuthManager.Cas.cert_path', APP . 'Config/cert_cas/client.pem');
Configure::write('AuthManager.Cas.proxy', 'https://auth.webgfc.fr');

Configure::write('Suffixe.connexion', '');

Configure::write('Sanscontact.id', 3209);

// Affichage de la bannette Les flux de mes services
Configure::write('Bannette.messervices', false);

// Utilisation de la restriction des types/sous-types selon les droits
Configure::write('Use.AuthRights', true);

// Paramètre permettant de ne pas charger les droits en édition d'un utilisateur
Configure::write('Afficher.HabilitationsUser', false);

// Paramètre utilisé, dans le cas d'une authentification CAS avec multi-collectivités côté web-GFC
Configure::write('Cas.Multicoll', false);

// Paramétrage pour le compte de la SAERP
Configure::write('Conf.SAERP', false);

// Paramétrage pour les circuits fantômes
Configure::write('Soustype.Fantome', 'S0');

// Paramétrage pour récupérer l'URL de l'outil de statistiques
Configure::write('Url.Stat', 'http://webgfc.stats');

// Paramétrage pour ne pas supprimer les flux en copie une foisle flux clôturé (false = Angoulême)
Configure::write('Vidage.Bannettecopie', false);
?>