<?php

App::uses('Controller', 'Controller');
App::uses('Model', 'AppModel');
App::uses('ComponentCollection', 'Controller');
App::uses('XShell', 'Console/Command');
App::uses('Folder', 'Utility');
App::uses('File', 'Utility');
App::uses('CakeTime', 'Utility');

/**
 *
 * CreateFromFiles shell class
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 *
 * @package		cake.app
 * @subpackage	cake.app.shell
 * @source http://adresse.data.gouv.fr
 */
class BanInsertShell extends XShell {


	/**
	 *
	 * @var type
	 */
	public $files = array();


	/**
	 *
	 * @var type
	 */
	public $Collectivite;

	/**
	 *
	 * @var type
	 */
	public $Ban;

	/**
	 *
	 * @throws FatalErrorException
	 */
	public function startup() {
		parent::startup();

        $this->_conn = 'default';
		if (!empty($this->params['connection'])) {
			Configure::write('conn', $this->params['connection']);
			$this->_conn = $this->params['connection'];
		}
        
		$this->Collectivite = ClassRegistry::init('Collectivite');
		$this->Collectivite->useDbConfig = 'default';
		$coll = $this->Collectivite->find('first', array('conditions' => array('Collectivite.conn' => $this->params['connection'])));

                
		Configure::write('conn', $this->params['connection']);

        ClassRegistry::config(array( 'ds' => $this->params['connection']));
		$this->Ban = ClassRegistry::init('Ban');
        $this->Ban->useDbConfig = $this->_conn;

        // verification et récupération des paramètres de scan (type local)
//        if( empty($this->params['file'])) {
//                if (!empty($coll) && $coll['Collectivite']['scan_access_type'] == 'local' && !empty($coll['Collectivite']['scan_local_path'])) {
//                        $repo = $coll['Collectivite']['scan_local_path'];
//                        $repoMerge = $repo . DS . 'merge';
//                        $repoOld = $repo . DS . 'old';
//                        $repoInvalid = $repoOld . DS . 'invalid';
//                }
//
//
//                //verfication et récupération du role destinataire
//                if (!empty($coll) && is_int($coll['Collectivite']['scan_desktop_id']) && $coll['Collectivite']['scan_desktop_id'] > 0) {
//                        $this->destDesktopId = $coll['Collectivite']['scan_desktop_id'];
//                }
//
//                if (!is_int($this->destDesktopId) || $this->destDesktopId <= 0) {
//                        throw new FatalErrorException('Le rôle destinataire n\'est pas défini');
//                }
//
//                $this->_checkRepositories($repo, $repoOld, $repoInvalid, $repoMerge);
//                $this->purgeDate = CakeTime::format('Ymd', '-1 week');
//                $this->files = $this->_getFiles();          
//                $this->oldFiles = $this->_getOldFiles();
//                $this->purgeableFiles = $this->_getOldFiles(true);
//                $this->invalidFiles = $this->_getInvalidFiles();
//        }else{
//                $scan = $this->Scanemail->find('first',array(
//                    'conditions' => array(
//                            'Scanemail.name' => $this->params['mailbox']
//                    ),
//                        'recursive' => -1
//                ));
//                $this->destDesktopId = $scan['Scanemail']['desktop_id'];
//                if (!is_int($this->destDesktopId) || $this->destDesktopId <= 0) {
//                        throw new FatalErrorException('Le rôle destinataire n\'est pas défini');
//                }
//                $this->collId = $coll['Collectivite']['id'];
//                $this->files = $this->_getMailByBox($this->params['mailbox']);
//        }
	}


	/**
	 *
	 */
	public function process() {
        if( !empty( $this->params['file']) && !empty( $this->params['departement']) ){
            $createdBan = array();
            $this->out('<info>Acquisition des adresses en cours ...</info>');
            $this->XProgressBar->start(1);

            
            
//            $this->Ban->importBanCsv($this->params['file'], $this->params['departement']);
            $this->importBanCsv($this->params['file'], $this->params['departement']);
            
//            $this->out('<info>Acquisition en cours ...</info>');
//            $this->XProgressBar->next();
//            $this->XProgressBar->finish();

            $this->hr();
            if (!in_array(false, $createdBan, true)) {
                $this->out('<success>Opération terminée avec succès.</success>');
            } else {
                $this->out('<error>Opération terminée avec erreur(s).</error>');
            }
            $this->hr();
        }
    }

	/**
	 *
	 * @return type
	 */
	public function getOptionParser() {
        $this->Ban = ClassRegistry::init('Ban');
        $departements = $this->Ban->listeDepartements();
        
        $optionParser = parent::getOptionParser();
        $optionParser->addOption('file', array(
			'short' => 'f',
            'help' => 'Nom du fichier BAN (format CSV) à intégrer'
		));
        
         $optionParser->addOption('departement', array(
			'short' => 'd',
            'help' => 'Nom du département concerné',
			'choices' => array_keys( $departements )
		));
                            
		return $optionParser;
	}
    
    
     
    /*
     * Fonction permettant d'intégrer le fichier BAN d'un département
     * 
     * 
     */

    private function _processCsv($ban) {
        //infos
        $libelleacheminement = ucwords( $ban['libelle_acheminement'] );
        $infos = array(
            'ident' => $ban['id'],
            'name' => !empty( $libelleacheminement ) ? $libelleacheminement : ucwords( $ban['nom_commune'] ),
            'nom_voie' => ucwords( $ban['nom_voie'] ),
            'id_fantoir' => $ban['id_fantoir'],
            'numero' => $ban['numero'],
            'rep' => $ban['rep'],
            'code_insee' => $ban['code_insee'],
            'code_post' => $ban['code_post'],
            'alias' => $ban['alias'],
            'nom_ld' => $ban['nom_ld'],
            'nom_afnor' => $ban['nom_afnor'],
            'libelle_acheminement' => $ban['libelle_acheminement'],
            'x' => $ban['x'],
            'y' => $ban['y'],
            'lon' => $ban['lon'],
            'lat' => $ban['lat'],
            'nom_commune' => $ban['nom_commune'],
            'active' => 1

        );
    

        $res = array(
            'infos' => $infos
        );
        return $res;
    }

    
    /**
     *
     * @param type $filename
     * @param type $ban_id
     * @param type $foreign_key
     * @return boolean
     */
    public function importBanCsv($filename = null, $departement_id = null,  $foreign_key = null) {
        $this->Ban->useDbConfig = $this->_conn;
        
//ini_set( 'memory_limit', '3000M');
        $return = array();
        if ($filename != null && is_file($filename) && is_readable($filename)) {
            if (($handle = fopen($filename, 'r')) !== FALSE) {
                //création du BAN selon le département
                $dept = substr( $departement_id, 0, -1 );
                $listeDepartements = $this->Ban->listeDepartements();
                $libelledir = Hash::get($listeDepartements, $departement_id );                    
                $ban['Ban']['name'] = strtoupper( $libelledir );
                $this->Ban->create();
                $banAd = $this->Ban->save($ban);

                if( !empty($banAd)) {
                    $this->out("Département créé");
                }
                else {
                    $this->out("Département déjà présent");
                }
                
                $banscommunes = array();
                $header = NULL;

                while (($row = fgetcsv($handle, 1000000, ';')) !== FALSE) {
                    if (!$header) {
                        $header = $row;
                    } else {
                        $tmp = array();
                        for ($i = 0; $i < count($header); $i++) {
                            $tmp[$header[$i]] = $row[$i];
                        }
                        $banscommunes[] = $tmp;
                    }
                }
                fclose($handle);
                
    /*            
    $values = file_get_contents($this->params['file']);
    if (($handle = fopen($this->params['file'], "r")) !== FALSE)
    {
        $i = 0; 
        while (($lines = fgetcsv($handle,1000,';')) !== FALSE) {
            if($i==0)
            foreach( $lines as $key => $val ) {
                $cols[$key] = trim($lines[$key]);
            }
            else
            {
                $fields=array();
                $this->Infosuplistedef->begin();
                foreach ($cols as $keyCol=>$name){
                    if(!empty($lines[$keyCol]))
                    $fields[$name] = trim($lines[$keyCol]);
                    else throw new Exception('Fichier invalide');
                }
                $fields['infosupdef_id']=$infosupdef['Infosupdef']['id'];
                $fields['ordre']=$i; 
                $this->Infosuplistedef->create();
                $this->Infosuplistedef->save($fields);
                $this->Infosuplistedef->commit();
                $this->out("Import : " . implode($fields));
            }
            $i++; 
        }
    }else{
        throw new Exception('Fichier invalide');
    }
          */      
                $this->XProgressBar->start(count($banscommunes)); 
                $this->out('<info>Enregistrement des adresses...</info>');
                foreach ($banscommunes as $bancommune) {
                    $adresseINFO = $this->_processCsv($bancommune);

                    // Sauvegarde des communes
                    $communeINFO = array();
                    $communeINFO['Bancommune']['name'] = $adresseINFO['infos']['nom_commune'];
                    $communeINFO['Bancommune']['ban_id'] = $banAd['Ban']['id'];

                    $commune = $this->Ban->Bancommune->find(
                        'first',
                        array(
                            'conditions' => array(
                                'Bancommune.name' => $communeINFO['Bancommune']['name']
                            ),
                            'recursive' => -1
                        )
                    );
                    if( !empty( $commune ) ) {
                        $bancommuneId = $commune['Bancommune']['id'];
                    }
                    else {
                        $this->Ban->Bancommune->create();
                        $savedCommune = $this->Ban->Bancommune->save($communeINFO);
                        $bancommuneId = $this->Ban->Bancommune->id;
                    }


                    // Sauvegarde des adresses
                    if(!empty( $bancommuneId )) {

                        //un seul ficher contact, realiser model contactInfo
                        $adresse = array();
                        // infos
                        $adresse['Banadresse'] = $adresseINFO['infos'];
//                        $adresseINFO['Banadresse']['name'] = $bancommuneId;
                        $adresse['Banadresse']['name'] = $adresseINFO['infos']['numero'].' '.$adresseINFO['infos']['rep'].' '.$adresseINFO['infos']['nom_voie'].' '.$adresseINFO['infos']['code_post'].' '.$adresseINFO['infos']['name'];
                        $adresse['Banadresse']['bancommune_id'] = $bancommuneId;
                        $this->Ban->Bancommune->Banadresse->create();
                        $savedAdresse = $this->Ban->Bancommune->Banadresse->save($adresse);
                        $saved = !empty($savedAdresse);
                        
                        if ($saved) {
                            $return[] = true;
                            $this->Ban->Bancommune->Banadresse->commit();
                            
                        } else {
                            $return[] = false;
                            $this->Ban->Bancommune->Banadresse->rollback();
                        }

                    }
                    $this->XProgressBar->next();
                }
                
                $this->XProgressBar->finish();
            }
        }
        return !in_array(false, $return, true);
    }
    
    
}

