<?php

App::uses('AppModel', 'Model');

/**
 * Bancontenu model class
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 * @package		app
 * @subpackage		app.Model
 */
class Bancontenu extends AppModel {

    /**
     *
     * @var type
     */
    public $name = 'Bancontenu';

    /**
     *
     * @var type
     */
    public $belongsTo = array(
        'Desktop' => array(
            'className' => 'Desktop',
            'foreignKey' => 'desktop_id',
            'type' => 'INNER',
            'conditions' => null,
            'fields' => null,
            'order' => null
        ),
        'Desktopmanager' => array(
            'className' => 'Desktopmanager',
            'foreignKey' => 'desktop_id',
            'type' => 'INNER',
            'conditions' => null,
            'fields' => null,
            'order' => null
        ),
//      'User' => array(
//          'className' => 'User',
//          'foreignKey' => 'user_id',
//          'type' => 'INNER',
//          'conditions' => null,
//          'fields' => null,
//          'order' => null
//      ),
        'Bannette' => array(
            'className' => 'Bannette',
            'foreignKey' => 'bannette_id',
            'type' => 'INNER',
            'conditions' => null,
            'fields' => null,
            'order' => null
        ),
        'Courrier' => array(
            'className' => 'Courrier',
            'foreignKey' => 'courrier_id',
            'type' => 'INNER',
            'conditions' => null,
            'fields' => null,
            'order' => null
        )
    );

    /**
     *
     *
     * etat :
     *      -1 refus
     *      0 validé
     *      1 à traiter
     *      2 terminé
     *
     * @param type $desktop_id
     * @param type $bannette_id
     * @param type $courrier_id
     * @return type
     */
    public function add($desktop_id = null, $bannette_id = null, $courrier_id = null, $read = false) {
        $ret = false;
        if ($desktop_id != null && $bannette_id != null && $courrier_id != null) {
            $bancontenu = $this->find(
                    'first', array(
                'conditions' => array(
                    'Bancontenu.desktop_id' => $desktop_id,
                    'Bancontenu.bannette_id' => $bannette_id,
                    'Bancontenu.courrier_id' => $courrier_id
                ),
                'contain' => false
                    )
            );
            if (empty($bancontenu)) {
                $content = $this->create();
                $content['Bancontenu']['desktop_id'] = $desktop_id;
                $content['Bancontenu']['bannette_id'] = $bannette_id;
                $content['Bancontenu']['courrier_id'] = $courrier_id;
                $content['Bancontenu']['read'] = $read;
                $ret = $this->save($content);
            } else {
                $bancontenu['Bancontenu']['etat'] = 1;
                $this->create($bancontenu);
                $ret = $this->save($bancontenu);
            }
        }
        return !empty($ret);
    }

    /**
     *
     * @param type $desktop_id
     * @param type $bannette_id
     * @param type $courrier_id
     * @return type
     */
    public function end($desktop_id = null, $bannette_id = null, $courrier_id = null) {
        $ret = false;
        /* $querydata = array(
          'conditions' => array(
          'Bancontenu.desktop_id' => $desktop_id,
          'Bancontenu.bannette_id' => $bannette_id,
          'Bancontenu.courrier_id' => $courrier_id
          )
          );
          debug(
          array(
          $desktop_id,
          $bannette_id,
          $courrier_id
          )
          );
          $item = $this->find('first', $querydata); */
        $item2 = $this->find(
                'first', array(
            'conditions' => array(
                'Bancontenu.desktop_id' => $desktop_id,
                'Bancontenu.bannette_id' => $bannette_id,
                'Bancontenu.courrier_id' => $courrier_id
            ),
            'contain' => false
                )
        );
        if (!empty($item2)) {
            $item2['Bancontenu']['etat'] = 0;
            $item2['Bancontenu']['read'] = true;
            $ret = $this->save($item2);
        }
        return !empty($ret);
    }

    /**
     *
     * @param type $courrier_id
     */
    public function fullend($courrier_id = null) {
        $retval = false;
        if ($courrier_id != null) {
            if(Configure::read('Vidage.Bannettecopie')) {
                $retval = $this->updateAll(array('Bancontenu.etat' => 2), array('Bancontenu.courrier_id' => $courrier_id));
            }
            else {
                $retval = $this->updateAll(
                    array('Bancontenu.etat' => 2),
                    array(
                        'Bancontenu.courrier_id' => $courrier_id,
                        'Bancontenu.bannette_id' => array(1,2,3,4,5,6) // Toutes sauf la bannette des flux en copie
                    )
                );
            }
        }
        return $retval;
    }

    /**
     *
     * @param type $courrier_id
     */
    public function cancel($courrier_id = null) {
        if ($courrier_id != null) {
            $this->query('update bancontenus set etat = -1 where courrier_id = ' . $courrier_id . ';');
        }
    }

    public function setRead($fluxId, $desktopId) {
        /* $qd = array(
          'recursive' => -1,
          'fields' => array(
          'Bancontenu.id',
          'Bancontenu.read'
          ),
          'conditions' => array(
          'Bancontenu.courrier_id' => $fluxId,
          'Bancontenu.desktop_id' => $desktopId
          )
          );
          $bancontenu = $this->find('first', $qd);

          $this->create();
          $bancontenu['Bancontenu']['read'] = true;

          $this->save($bancontenu); */
        $this->Courrier->Bancontenu->updateAll(
                array('Bancontenu.read' => true), array(
            'Bancontenu.courrier_id' => $fluxId,
            'Bancontenu.desktop_id' => $desktopId
                )
        );
    }

    /**
     * Retourne une sous-requête permettant de cibler la dernière bannette
     * d'un courrier pour une année donnée.
     * * etat :
     *      2 terminé
     * @param type $annee
     * @return type
     */
    public function sqDerniereBannette($courrierIdFied, $etat = null) {
        $courrierIdFied = 'Courrier.id';

        $conditions = array(
            "bancontenus.courrier_id = {$courrierIdFied}"
        );
        if (isset($etat)) {
            if (is_array($etat)) {
                $etat = implode(' ,', $etat);
                $conditions[] = array("bancontenus.etat IN ( {$etat} )");
            } else {
                $conditions[] = array("bancontenus.etat = {$etat}");
            }
        }
        $dbo = $this->getDataSource($this->useDbConfig);
        $table = $dbo->fullTableName($this, false, false);

        return "
                    SELECT {$table}.id
                            FROM {$table}
                            WHERE
                                    {$table}.courrier_id = " . $courrierIdFied . "
                                    AND {$table}.bannette_id <> '7'
                            ORDER BY {$table}.created DESC
                            LIMIT 1
            ";

//        return $this->sq(
//            array(
//                'fields' => array(
//                    'bancontenus.id'
//                ),
//                'alias' => 'bancontenus',
//                'conditions' => $conditions,
//                'order' => array( 'bancontenus.created DESC' ),
//                'limit' => 1
//            )
//        );
    }

    /**
     * Retourne une sous-requête permettant de cibler la dernière bannette
     * d'un courrier pour une année donnée.
     * * etat :
     *      2 terminé
     * @param type $annee
     * @return type
     */
    public function sqDerniereBannetteRecherche($courrierIdFied, $etat = null) {
        $courrierIdFied = 'Courrier.id';

        $conditions = array(
            "bancontenus.courrier_id = {$courrierIdFied}"
        );
        if (isset($etat)) {
            if (is_array($etat)) {
                $etat = implode(' ,', $etat);
                $conditions[] = array("bancontenus.etat IN ( {$etat} )");
            } else {
                $conditions[] = array("bancontenus.etat = {$etat}");
            }
        }
        $dbo = $this->getDataSource($this->useDbConfig);
        $table = $dbo->fullTableName($this, false, false);

        return "
                SELECT {$table}.id
                        FROM {$table}
                        WHERE
                                {$table}.courrier_id = " . $courrierIdFied . "
                        ORDER BY {$table}.created DESC
                        LIMIT 1
        ";

//        return $this->sq(
//            array(
//                'fields' => array(
//                    'bancontenus.id'
//                ),
//                'alias' => 'bancontenus',
//                'conditions' => $conditions,
//                'order' => array( 'bancontenus.created DESC' ),
//                'limit' => 1
//            )
//        );
    }

    /**
     *
     * @param type $courrier_id
     */
    public function refus($desktop_id, $courrier_id = null) {
        if ($desktop_id != null && $courrier_id != null) {
            $this->query('INSERT INTO bancontenus (courrier_id, desktop_id, etat, read, created, modified) VALUES ( ' . $courrier_id . ', ' . $desktop_id . ', -1, true, NOW(), NOW() )');
        }
    }

    public function getBannetteIdByCourrierIdDesktopId($courrier_id, $desktop_id) {
        if ($courrier_id != null) {
            $bannetteId = '';
            $bancontenu = $this->find('first', array('conditions' => array('Bancontenu.courrier_id' => $courrier_id, 'Bancontenu.desktop_id' => $desktop_id, 'Bancontenu.etat' => 1), 'contain' => false));
            if( !empty($bancontenu) ) {
                $bannetteId = $bancontenu['Bancontenu']['bannette_id'];
            }
            return $bannetteId;
        }
    }

}

?>