<?php

App::uses('AppModel', 'Model');

/**
 * Recherche model class
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 * @package		app
 * @subpackage		app.Model
 */
class Recherche extends AppModel {

    /**
     *
     * @var type
     */
    public $name = 'Recherche';

    /**
     *
     * @var type
     */
    public $validate = array();

    /**
     *
     * @var type
     */
    public $belongsTo = array(
        'User' => array(
            'className' => 'User',
            'foreignKey' => 'user_id'
        )
    );

    /**
     * 
     */
    public $hasMany = array(
        'RechercheSelectvaluemetadonnee' => array(
            'className' => 'RechercheSelectvaluemetadonnee',
            'foreignKey' => 'recherche_id',
            'dependent' => false,
            'conditions' => '',
            'fields' => '',
            'order' => '',
            'limit' => '',
            'offset' => '',
            'exclusive' => '',
            'finderQuery' => '',
            'counterQuery' => ''
        )
    );

    /**
     *
     * @var type
     */
    public $hasAndBelongsToMany = array(
        'Metadonnee' => array(
            'className' => 'Metadonnee',
            'joinTable' => 'recherches_metadonnees',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'metadonnee_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheMetadonnee'
        ),
        'Circuit' => array(
            'className' => 'Cakeflow.Circuit',
            'joinTable' => 'recherches_circuits',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'circuit_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheCircuit'
        ),
        'Dossier' => array(
            'className' => 'Dossier',
            'joinTable' => 'recherches_dossiers',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'dossier_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheDossier'
        ),
        'Affaire' => array(
            'className' => 'Affaire',
            'joinTable' => 'recherches_affaires',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'affaire_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheAffaire'
        ),
        'Type' => array(
            'className' => 'Type',
            'joinTable' => 'recherches_types',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'type_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheType'
        ),
        'Soustype' => array(
            'className' => 'Soustype',
            'joinTable' => 'recherches_soustypes',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'soustype_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheSoustype'
        ),
        'Tache' => array(
            'className' => 'Tache',
            'joinTable' => 'recherches_taches',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'tache_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheTache'
        ),
// 		'Vcard' => array(
// 			'className' => 'Vcard',
// 			'joinTable' => 'recherches_vcards',
// 			'foreignKey' => 'recherche_id',
// 			'associationForeignKey' => 'vcard_id',
// 			'unique' => null,
// 			'conditions' => null,
// 			'fields' => null,
// 			'order' => null,
// 			'limit' => null,
// 			'offset' => null,
// 			'finderQuery' => null,
// 			'deleteQuery' => null,
// 			'insertQuery' => null,
// 			'with' => 'RechercheVcard'
// 		),
        'Contact' => array(
            'className' => 'Contact',
            'joinTable' => 'recherches_contacts',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'contact_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheContact'
        ),
        'Addressbook' => array(
            'className' => 'Addressbook',
            'joinTable' => 'recherches_addressbooks',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'addressbook_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheAddressbook'
        ),
        'Desktop' => array(
            'className' => 'Desktop',
            'joinTable' => 'recherches_desktops',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'desktop_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheDesktop'
        ),
        'Organisme' => array(
            'className' => 'Organisme',
            'joinTable' => 'recherches_organismes',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'organisme_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheOrganisme'
        ),
        'Service' => array(
            'className' => 'Service',
            'joinTable' => 'recherches_services',
            'foreignKey' => 'recherche_id',
            'associationForeignKey' => 'service_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'RechercheService'
        )
    );

    /**
     * Recherche de flux
     */
    public function search($params, $id = null, $datasAuthorizedType = array()) {
        $conditions = array();
        $Courrier = ClassRegistry::init('Courrier');

        $joins = array(
            $Courrier->join('Contact', array('type' => 'LEFT OUTER')),
            $Courrier->join('Organisme', array('type' => 'LEFT OUTER')),
            $Courrier->join('Soustype', array('type' => 'LEFT OUTER')),
            $Courrier->Soustype->join('Type', array('type' => 'LEFT OUTER')),
            $Courrier->join('Traitement', array('type' => 'LEFT OUTER')),
            $Courrier->Traitement->join('Circuit', array('type' => 'LEFT OUTER')),
            $Courrier->join('Affaire', array('type' => 'LEFT OUTER')),
            $Courrier->Affaire->join('Dossier', array('type' => 'LEFT OUTER')),
            $Courrier->join('Affairesuivie', array('type' => 'LEFT OUTER')),
            $Courrier->join('Desktop', array('type' => 'LEFT OUTER'))
        );
        $contain = false;
        $order = array(
            'Courrier.date',
            'Courrier.datereception',
            'Courrier.name'
        );
        $fields = array_merge(
                $Courrier->fields(), $Courrier->Organisme->fields(), $Courrier->Contact->fields(), $Courrier->Soustype->fields(), $Courrier->Soustype->Type->fields(), $Courrier->Traitement->fields(), $Courrier->Traitement->Circuit->fields(), $Courrier->Affaire->fields(), $Courrier->Affaire->Dossier->fields(), array(
            'Affairesuivie.name'
                ), $Courrier->Bancontenu->fields(), $Courrier->Desktop->fields()
        );
//debug($params);
        //critères Recherches
        if (!empty($params['Recherche']['cname'])) {
            $conditions[] = 'NOACCENTS_UPPER(Courrier.name) LIKE \'' . $this->wildcard('%' . noaccents_upper( $params['Recherche']['cname'] ) . '%') . '\'';
//            $conditions[] = array('Courrier.name ILIKE' => $Courrier->wildcard("*{$params['Recherche']['cname']}*"));
        }

        // Objet du courrier
//        if ($params['Recherche']['cobjet'] != "") {
        if (!empty($params['Recherche']['cobjet'])) {
            $conditions[] = array('Courrier.objet ILIKE' => $Courrier->wildcard("*{$params['Recherche']['cobjet']}*"));
        }

        // Commentaire
        if (isset($params['Recherche']['ccomment']) && !empty($params['Recherche']['ccomment'])) {

            //'SELECT comment.target_id FROM comments WHERE comments.slug '
            $sq = $Courrier->Comment->sq(
                    array(
                        'fields' => array('comments.target_id'),
                        'alias' => 'comments',
                        'conditions' => array(
                            //'comments.slug ILIKE' => $Courrier->wildcard("*{$params['Recherche']['ccomment']}*")
                            'NOACCENTS_UPPER( comments.slug ) LIKE' => noaccents_upper($Courrier->wildcard("*{$params['Recherche']['ccomment']}*"))
                        ),
                        'contain' => false
                    )
            );
            $conditions[] = array("Courrier.id IN ( {$sq} )");
        }
        //critères Recherches
        if (!empty($params['Recherche']['creference'])) {
            $conditions[] = array('Courrier.reference ILIKE' => $Courrier->wildcard("*{$params['Recherche']['creference']}*"));
        }

        //critères Recherches
        if (!empty($params['Recherche']['corigineflux_id'])) {
            $conditions[] = array('Courrier.origineflux_id' => $params['Recherche']['corigineflux_id']);
        }
        //Critères sur les dates d'entrée en collectivité
        if (isset($params['Recherche']['cdate']) && !empty($params['Recherche']['cdate'])) {
            if (isset($params['Recherche']['cdatefin']) && !empty($params['Recherche']['cdatefin'])) {
                $conditions[] = array(
                    'AND' => array(
                        array(
                            'Courrier.date >=' => $params['Recherche']['cdate']
                        ),
                        array(
                            'Courrier.date <=' => $params['Recherche']['cdatefin']
                        )
                    )
                );
            } else {
                $conditions[] = array('Courrier.date' => $params['Recherche']['cdate']);
            }
        }

        //Critères sur les dates de réception par la collectivité
        if (isset($params['Recherche']['cdatereception']) && !empty($params['Recherche']['cdatereception'])) {
            if (isset($params['Recherche']['cdatereceptionfin']) && !empty($params['Recherche']['cdatereceptionfin'])) {
                $conditions[] = array('AND' => array(array('Courrier.datereception >=' => $params['Recherche']['cdatereception']), array('Courrier.datereception <=' => $params['Recherche']['cdatereceptionfin'])));
            } else {
                $conditions[] = array('Courrier.datereception' => $params['Recherche']['cdatereception']);
            }
        }

        //critères Affaire suviie par
        if (!empty($params['Desktop']['Desktop'])) {
            $conditions[] = array('Courrier.affairesuiviepar_id' => $params['Desktop']['Desktop']);
        }

        //critères Organisme
        if (!empty($params['Recherche']['organismename'])) {
            $conditions[] = array('Organisme.name ILIKE' => $Courrier->Organisme->wildcard("*{$params['Recherche']['organismename']}*"));
        } else if (!empty($params['Organisme']['Organisme'])) {
            $organisme_conditions = array();
            foreach ($params['Organisme']['Organisme'] as $organisme_id) {
                $organisme_conditions[] = array('Courrier.organisme_id' => $organisme_id);
            }
            $conditions[] = array('OR' => $organisme_conditions);
        } else if ($id != null && !empty($params['Organisme'])) {
            $organisme_conditions = array();
            foreach ($params['Organisme'] as $organisme) {
                $organisme_conditions[] = array('Courrier.organisme_id' => $organisme['id']);
            }
            $conditions[] = array('OR' => $organisme_conditions);
        }

        //critères Contact
        if (!empty($params['Recherche']['contactname'])) {
            $conditions[] = array('Contact.name ILIKE' => $Courrier->Contact->wildcard("*{$params['Recherche']['contactname']}*"));
        } else if (!empty($params['Contact']['Contact'])) {
            $contact_conditions = array();
            foreach ($params['Contact']['Contact'] as $contact_id) {
                $contact_conditions[] = array('Courrier.contact_id' => $contact_id);
            }
            $conditions[] = array('OR' => $contact_conditions);
        } else if ($id != null && !empty($params['Contact'])) {
            $contact_conditions = array();
            foreach ($params['Contact'] as $contact) {
                $contact_conditions[] = array('Courrier.contact_id' => $contact['id']);
            }
            $conditions[] = array('OR' => $contact_conditions);
        }

        //critères Type
        if (!empty($params['Type']['Type'])) {
            $type_conditions = array();
            foreach ($params['Type']['Type'] as $type_id) {
//				$type_conditions[] = array('Type.id' => $type_id);
                $type_conditions[] = array('Soustype.type_id' => $type_id);
            }
            $conditions[] = array('OR' => $type_conditions);
        } else if ($id != null && !empty($params['Type'])) {
            $type_conditions = array();
            foreach ($params['Type'] as $type) {
//				$type_conditions[] = array('Type.id' => $type['id']);
                $type_conditions[] = array('Soustype.type_id' => $type['id']);
            }
            $conditions[] = array('OR' => $type_conditions);
        } else {
            if (!empty($datasAuthorizedType)) {
                $type_conditions = array();
                foreach ($datasAuthorizedType as $type_id => $sousTypeId) {
                    $type_conditions[] = array('Soustype.type_id' => $type_id);
                    $type_conditions[] = array('Soustype.id' => $sousTypeId);
                }
                $conditions[] = array('OR' => $type_conditions);
            }
        }

        //critères Soustype
        if (!empty($params['Soustype']['Soustype'])) {
            $soustype_conditions = array();
            foreach ($params['Soustype']['Soustype'] as $soustype_id) {
                $soustype_conditions[] = array('Courrier.soustype_id' => $soustype_id);
            }
            $conditions[] = array('OR' => $soustype_conditions);
        } else if ($id != null && !empty($params['Soustype'])) {
            $soustype_conditions = array();
            foreach ($params['Soustype'] as $soustype) {
                $soustype_conditions[] = array('Courrier.soustype_id' => $soustype['id']);
            }
            $conditions[] = array('OR' => $soustype_conditions);
        }

        //critères Metadonnee
        $meta_conditions = array();
        $joinmeta = false;

// debug($params);
        // Recherche sur les valeurs présentes pour les métadonnées
        if (!empty($params['Selectvaluemetadonnee']['Selectvaluemetadonnee'])) {
            foreach ($params['Selectvaluemetadonnee']['Selectvaluemetadonnee'] as $kmeta => $meta) {
                if ($meta != '') {
                    if (!$joinmeta) {
                        $joins[] = $Courrier->join($Courrier->CourrierMetadonnee->alias);
                        $joinmeta = true;
                    }
                    $meta_conditions[] = array('CourrierMetadonnee.valeur LIKE' => $Courrier->CourrierMetadonnee->wildcard("*{$meta}*"));
                }
            }
            if (!empty($meta_conditions)) {
                $conditions[] = array('AND' => $meta_conditions);
            }
        }

        if (!empty($params['Metadonnee']['Metadonnee'])) {
            foreach ($params['Metadonnee']['Metadonnee'] as $kmeta => $meta) {
                if ($meta != '') {
                    if (!$joinmeta) {
                        $joins[] = $Courrier->join($Courrier->CourrierMetadonnee->alias);
                        $joinmeta = true;
                    }
                    $meta_conditions[] = array(
                        array('CourrierMetadonnee.metadonnee_id' => $meta)
                    );
                }
            }
            if (!empty($meta_conditions)) {
                $conditions[] = array('AND' => $meta_conditions);
            }
        }


        //critères Circuit
        if (!empty($params['Circuit']['Circuit'])) {
            $circuit_conditions = array();
            foreach ($params['Circuit']['Circuit'] as $circuit_id) {
                $circuit_conditions[] = array('Circuit.id' => $circuit_id);
            }
            $conditions[] = array('OR' => $circuit_conditions);
        } else if ($id != null && !empty($params['Circuit'])) {
            $circuit_conditions = array();
            foreach ($params['Circuit'] as $circuit) {
                $circuit_conditions[] = array('Circuit.id' => $circuit['id']);
            }
            $conditions[] = array('OR' => $circuit_conditions);
        }

        //critères Dossier
        if (!empty($params['Dossier']['Dossier'])) {
            $dossier_conditions = array();
            foreach ($params['Dossier']['Dossier'] as $dossier_id) {
                $dossier_conditions[] = array('Dossier.id' => $dossier_id);
            }
            $conditions[] = array('OR' => $dossier_conditions);
        } else if ($id != null && !empty($params['Dossier'])) {
            $dossier_conditions = array();
            foreach ($params['Dossier'] as $dossier) {
                $dossier_conditions[] = array('Dossier.id' => $dossier['id']);
            }
            $conditions[] = array('OR' => $dossier_conditions);
        }

        //critères Affaire
        if (!empty($params['Affaire']['Affaire'])) {
            $affaire_conditions = array();
            foreach ($params['Affaire']['Affaire'] as $affaire_id) {
                $affaire_conditions[] = array('Courrier.affaire_id' => $affaire_id);
            }
            $conditions[] = array('OR' => $affaire_conditions);
        } else if ($id != null && !empty($params['Affaire'])) {
            $affaire_conditions = array();
            foreach ($params['Affaire'] as $affaire) {
                $affaire_conditions[] = array('Courrier.affaire_id' => $affaire['id']);
            }
            $conditions[] = array('OR' => $affaire_conditions);
        }

        //critères Tache
        if (isset($params['Tache']['Tache']) && !empty($params['Tache']['Tache'])) {
            $joins[] = $Courrier->join(
                    'Tache', array(
                'type' => 'INNER',
                'conditions' => array(
                    "Tache.courrier_id = Courrier.id"
                )
                    )
            );
            $sqTache = $Courrier->Tache->sq(
                    array(
                        'fields' => array('taches.courrier_id'),
                        'alias' => 'taches',
                        'conditions' => array(
                            'taches.id' => $params['Tache']['Tache']
                        ),
                        'contain' => false
                    )
            );
            $conditions[] = array("Courrier.id IN ( {$sqTache} )");
        }

        if (!empty($params['Tache']['Tache'])) {
            $type_conditions = array();
            foreach ($params['Tache']['Tache'] as $tache_id) {
                $tache_conditions[] = array('Tache.id' => $tache_id);
            }
            $conditions[] = array('OR' => $tache_conditions);
        } else if ($id != null && !empty($params['Tache'])) {
            $type_conditions = array();
            foreach ($params['Tache'] as $tache) {
                $tache_conditions[] = array('Tache.id' => $tache['id']);
            }
            $conditions[] = array('OR' => $tache_conditions);
        }


        //critères Recherches sur les adresses
        if (!empty($params['Recherche']['contactadresse'])) {
            $conditions[] = array('Contact.banadresse' => $params['Recherche']['contactadresse']);
        }
        if (!empty($params['Recherche']['contactdept'])) {
            $conditions[] = array('Contact.ban_id' => $params['Recherche']['contactdept']);
        }

        if (!empty($params['Recherche']['contactcommune'])) {
            $conditions[] = array('Contact.bancommune_id' => $params['Recherche']['contactcommune']);
        }

        if (!empty($params['Recherche']['contactnomvoie'])) {
            $conditions[] = array('Contact.banadresse LIKE' => $Courrier->Contact->wildcard("*{$params['Recherche']['contactnomvoie']}*"));
        }

        //critères Recherches sur les adresses
        if (!empty($params['Recherche']['organismedepartement'])) {
            $conditions[] = array('Organisme.ban_id' => $params['Recherche']['organismedepartement']);
        }
        if (!empty($params['Recherche']['organismeadresse'])) {
            $conditions[] = array('Organisme.banadresse' => $params['Recherche']['organismeadresse']);
        }

        if (!empty($params['Recherche']['organismecommune'])) {
            $conditions[] = array('Organisme.bancommune_id' => $params['Recherche']['organismecommune']);
        }

        if (!empty($params['Recherche']['organismenomvoie'])) {
            $conditions[] = array('Organisme.banadresse LIKE' => $Courrier->Contact->wildcard("*{$params['Recherche']['organismenomvoie']}*"));
        }


        //debug($params['Recherche']['cetat']);
        if (isset($params['Recherche']['cetat']) && ($params['Recherche']['cetat'] != '' )) {
            $etat = $params['Recherche']['cetat'];
            $sqBancontenu = $Courrier->Bancontenu->sqDerniereBannetteRecherche('Courrier.id', $etat);
            $conditions[] = array('Bancontenu.etat' => $params['Recherche']['cetat']);
        } else {
            $sqBancontenu = $Courrier->Bancontenu->sqDerniereBannetteRecherche('Courrier.id');
        }

// critères Service
        if (!empty($params['Service']['Service'])) {
            $joins[] = $Courrier->Bancontenu->Desktop->join(
                    'DesktopsService', array(
                'type' => 'LEFT OUTER'
                    )
            );
            $joins[] = $Courrier->Bancontenu->Desktop->DesktopsService->join(
                    'Service', array(
                'type' => 'LEFT OUTER'
                    )
            );
            $service_conditions = array();
            foreach ($params['Service']['Service'] as $service_id) {

                $service_conditions[] = array('DesktopsService.service_id' => $service_id);
            }
            $conditions[] = array('OR' => $service_conditions);
        } else if ($id != null && !empty($params['Service'])) {
            $service_conditions = array();
            foreach ($params['Service'] as $service) {
                $service_conditions[] = array('DesktopsService.service_id' => $service['id']);
            }
            $conditions[] = array('OR' => $service_conditions);
        }
//debug($params);
//debug($conditions);

        if (Configure::read('Conf.SAERP')) {
            if (!empty($params['Recherche']['cmarche_id'])) {
                $conditions[] = array('Marche.id' => $params['Recherche']['cmarche_id']);
            }
            if (!empty($params['Recherche']['cos'])) {
                $joins[] = $Courrier->join(
                        'Ordreservice', array(
                    'type' => 'INNER',
                    'conditions' => array(
                        "Ordreservice.courrier_id = Courrier.id"
                    )
                        )
                );
                $sqOs = $Courrier->Ordreservice->sq(
                        array(
                            'fields' => array('ordresservices.courrier_id'),
                            'alias' => 'ordresservices',
                            'conditions' => array(
                                'ordresservices.id' => $params['Recherche']['cos']
                            ),
                            'contain' => false
                        )
                );
                $conditions[] = array("Courrier.id IN ( {$sqOs} )");
            }
            if (!empty($params['Recherche']['cplis'])) {
                $joins[] = $Courrier->join(
                        'Pliconsultatif', array(
                    'type' => 'INNER',
                    'conditions' => array(
                        "Pliconsultatif.courrier_id = Courrier.id"
                    )
                        )
                );
                $sqPlis = $Courrier->Pliconsultatif->sq(
                        array(
                            'fields' => array('plisconsultatifs.courrier_id'),
                            'alias' => 'plisconsultatifs',
                            'conditions' => array(
                                'plisconsultatifs.id' => $params['Recherche']['cplis']
                            ),
                            'contain' => false
                        )
                );
                $conditions[] = array("Courrier.id IN ( {$sqPlis} )");
            }

            $joins[] = $Courrier->join('Marche', array('LEFT OUTER'));
            $fields = array_merge($fields, $Courrier->Marche->fields());
            $joins[] = $Courrier->Soustype->Type->join('Operation', array('LEFT OUTER'));
            $fields = array_merge($fields, $Courrier->Soustype->Type->Operation->fields());

            if( isset($params['Recherche']['cnumeroop']) && !empty($params['Recherche']['cnumeroop']) ) {
                $conditions[] = array("Operation.id IN ( {$params['Recherche']['cnumeroop']} )");
            }
            
            
            if( isset($params['Recherche']['cnumerorar']) && !empty($params['Recherche']['cnumerorar']) ) {
                $joins[] = $Courrier->join(
                    'CourrierMetadonnee',
                    array(
                        'type' => 'LEFT OUTER',
                        'conditions' => array(
                            'CourrierMetadonnee.id' => $params['Recherche']['cnumerorar']
                        )
                    )
                );
                $conditions[] = array("CourrierMetadonnee.id IN ( {$params['Recherche']['cnumerorar']} )");
            }

            if (isset($params['Recherche']['ctypedocument']) && !empty($params['Recherche']['ctypedocument'])) {
                if ($params['Recherche']['ctypedocument'] == 'OS') {
                    $joins[] = $Courrier->join(
                            'Ordreservice', array(
                        'type' => 'INNER',
                        'conditions' => array(
                            "Ordreservice.courrier_id = Courrier.id"
                        )
                            )
                    );
                    $fields = array_merge($fields, $Courrier->Ordreservice->fields());
                    $sqOs = $Courrier->Ordreservice->sq(
                            array(
                                'fields' => array('ordresservices.courrier_id'),
                                'alias' => 'ordresservices',
                                'contain' => false
                            )
                    );

                    $conditions[] = array("Courrier.id IN ( {$sqOs} )");
                }
                if ($params['Recherche']['ctypedocument'] == 'PLI') {
                    $joins[] = $Courrier->join(
                            'Pliconsultatif', array(
                        'type' => 'INNER',
                        'conditions' => array(
                            "Pliconsultatif.courrier_id = Courrier.id"
                        )
                            )
                    );
                    $fields = array_merge($fields, $Courrier->Pliconsultatif->fields());
                    $sqPlis = $Courrier->Pliconsultatif->sq(
                            array(
                                'fields' => array('plisconsultatifs.courrier_id'),
                                'alias' => 'plisconsultatifs',
                                'contain' => false
                            )
                    );
                    $conditions[] = array("Courrier.id IN ( {$sqPlis} )");
                }
                if ( isset($params['Recherche']['ctypedocument']) && ($params['Recherche']['ctypedocument'] != '' ) || in_array($params['Recherche']['ctypedocument'], array('LN', 'LC')) || !empty( $params['Recherche']['cnumerorar'] ) ) {
                    $Metadonnee = ClassRegistry::init('Metadonnee');
                    $metaDatas = $Metadonnee->find('first', array('conditions' => array('Metadonnee.id' => Configure::read('MetadonnneMontant.id')), 'recursive' => -1));
                    $metaDatasRAR = $Metadonnee->find('first', array('conditions' => array('Metadonnee.name' => 'N° RAR'), 'recursive' => -1));
                    $metaDatasMetadonneeId = (isset($metaDatas['Metadonnee']['id'])) ? $metaDatas['Metadonnee']['id'] : 0;
//debug($metaDatas);
//die();
//                    if( !empty($metaDatas) && empty($metaDatasRAR) ) {
//                        $joins[] = $Courrier->join(
//                                'CourrierMetadonnee', array(
//                            'type' => 'LEFT OUTER',
//                            'conditions' => array(
//                                'CourrierMetadonnee.metadonnee_id' => $metaDatasMetadonneeId
//                            )
//                                )
//                        );
//                        $fields = array_merge($fields, $Courrier->CourrierMetadonnee->fields());
//
//                        $joins[] = $Courrier->CourrierMetadonnee->join(
//                                'Metadonnee', array(
//                            'type' => 'LEFT OUTER'
//                                )
//                        );
//                        $fields = array_merge($fields, $Courrier->CourrierMetadonnee->Metadonnee->fields());
//                    }

                    $conditions[] = array('Courrier.typedocument' => $params['Recherche']['ctypedocument']);
                    
                    
                    if (isset($params['Recherche']['cdatefilter']) && !empty($params['Recherche']['cdatefilter'])) {
                        if (isset($params['Recherche']['cdatefilterfin']) && !empty($params['Recherche']['cdatefilterfin'])) {
                            $conditions[] = array('AND' => array(array('Courrier.created >=' => $params['Recherche']['cdatefilter']), array('Courrier.created <=' => $params['Recherche']['cdatefilterfin'])));
                        } else {
                            $conditions[] = array('Courrier.created' => $params['Recherche']['cdatefilter']);
                        }
                    }
                }
            }

              // Filtre pour les activités
            if( isset($params['Activite']['Activite']) && !empty($params['Activite']['Activite']) ) {
                $joins[] = $Courrier->Organisme->join(
                    'ActiviteOrganisme',
                    array(
                        'type' => 'LEFT OUTER',
                        'conditions' => array(
                            'ActiviteOrganisme.activite_id' => $params['Activite']['Activite']
                        )
                    )
                );
                $fields = array_merge( $fields, $Courrier->Organisme->ActiviteOrganisme->fields() );
                
                $activitesOrgs = $Courrier->Organisme->ActiviteOrganisme->find(
                    'all',
                    array(
                        'conditions' => array(
                            'ActiviteOrganisme.activite_id' => $params['Activite']['Activite']
                        ),
                        'recursive' => -1
                    )
                );
                $orgsIds = Hash::extract( $activitesOrgs, '{n}.ActiviteOrganisme.organisme_id');
                $conditions[] = array(
                    'Courrier.organisme_id' => $orgsIds,
                    'Courrier.organisme_id IS NOT NULL'
                );
            }
            
            // Filtre pour les évenements
            if( isset($params['Event']['Event']) && !empty($params['Event']['Event']) ) {
                $joins[] = $Courrier->Contact->join(
                    'ContactEvent',
                    array(
                        'type' => 'LEFT OUTER',
                        'conditions' => array(
                            'ContactEvent.event_id' => $params['Event']['Event']
                        )
                    )
                );
                $fields = array_merge( $fields, $Courrier->Contact->ContactEvent->fields() );
                
                $eventsContacts = $Courrier->Contact->ContactEvent->find(
                    'all',
                    array(
                        'conditions' => array(
                            'ContactEvent.event_id' => $params['Event']['Event']
                        ),
                        'recursive' => -1
                    )
                );
                $contactsIds = Hash::extract( $eventsContacts, '{n}.ContactEvent.contact_id');

                $conditions[] = array(
                    'Courrier.contact_id' => $contactsIds,
                    'Courrier.contact_id IS NOT NULL'
                );
            }
            
            // Filtre pour les fonctions
            if( isset($params['Fonction']['Fonction']) && !empty($params['Fonction']['Fonction']) ) {
                $contacts = $Courrier->Contact->find(
                    'all',
                    array(
                        'conditions' => array(
                            'Contact.fonction_id' => $params['Fonction']['Fonction']
                        ),
                        'recursive' => -1
                    )
                );
                $contactsIds = Hash::extract( $contacts, '{n}.Contact.id');

                $conditions[] = array(
                    'Courrier.contact_id' => $contactsIds,
                    'Courrier.contact_id IS NOT NULL'
                );
            }
            
            if( !isset($params['Recherche']['ctypedocument']) ) {
                $Metadonnee = ClassRegistry::init('Metadonnee');
                $metaDatas = $Metadonnee->find('first', array('conditions' => array('Metadonnee.id' => Configure::read('MetadonnneMontant.id')), 'recursive' => -1));
                $metaDatasMetadonneeId = (isset($metaDatas['Metadonnee']['id'])) ? $metaDatas['Metadonnee']['id'] : 0;
//        debug($metaDatas);
//        die();
                if( !empty($metaDatas)) {
                    $joins[] = $Courrier->join(
                            'CourrierMetadonnee', array(
                        'type' => 'LEFT OUTER',
                        'conditions' => array(
                            'CourrierMetadonnee.metadonnee_id' => $metaDatasMetadonneeId
                        )
                            )
                    );
                    $fields = array_merge($fields, $Courrier->CourrierMetadonnee->fields());

                    $joins[] = $Courrier->CourrierMetadonnee->join(
                            'Metadonnee', array(
                        'type' => 'LEFT OUTER'
                            )
                    );
                    $fields = array_merge($fields, $Courrier->CourrierMetadonnee->Metadonnee->fields());
                }
            }
        }
//debug($params);
//debug($conditions);



        $joins[] = $Courrier->join(
                'Bancontenu', array(
            'type' => 'INNER',
            'conditions' => array(
                "Bancontenu.id IN ( {$sqBancontenu} )"
            )
                )
        );
//debug($params);
        if (isset($params['Recherche']['cretard'])) {
            if ($params['Recherche']['cretard'] == 'Oui') {

                $conditions[] = array('Bancontenu.etat NOT IN (-1, 2)');
                //            $conditions[] = array('"Courrier__retard"' => true );
                $conditions[] = array(
                    '( CASE
                        WHEN "Courrier"."delai_unite" = \'0\' THEN ( ( "Courrier"."datereception" + ( "Courrier"."delai_nb" * INTERVAL \'1 day\' ) ) < NOW() )
                        WHEN "Courrier"."delai_unite" = \'1\' THEN ( ( "Courrier"."datereception" + ( "Courrier"."delai_nb" * INTERVAL \'1 week\' ) ) < NOW() )
                        WHEN "Courrier"."delai_unite" = \'2\'  THEN ( ( "Courrier"."datereception" + ( "Courrier"."delai_nb" * INTERVAL \'1 month\' ) ) < NOW() )
                        ELSE false
                    END )'
                );
            } else if ($params['Recherche']['cretard'] == 'Non') {
                $conditions[] = array(
                    '( CASE
                        WHEN "Courrier"."delai_unite" = \'0\' THEN ( ( "Courrier"."datereception" + ( "Courrier"."delai_nb" * INTERVAL \'1 day\' ) ) >= NOW() )
                        WHEN "Courrier"."delai_unite" = \'1\' THEN ( ( "Courrier"."datereception" + ( "Courrier"."delai_nb" * INTERVAL \'1 week\' ) ) >= NOW() )
                        WHEN "Courrier"."delai_unite" = \'2\' THEN ( ( "Courrier"."datereception" + ( "Courrier"."delai_nb" * INTERVAL \'1 month\' ) ) >= NOW() )
                        ELSE false
                    END )'
                );
            }
        }

        $query = array(
            'fields' => $fields,
            'recursive' => -1,
            'joins' => $joins,
            'conditions' => $conditions,
            'order' => $order,
            'contain' => $contain
        );
// debug($this->sq( $query ) );
        return $query;
    }

}

?>
