<?php

/**
 *
 * Contacts/add.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php 
echo $this->Html->script('formValidate.js', array('inline' => true));
echo $this->Html->script('jquery/jquery.ui.autocomplete.html.js', array('inline' => true));
?>
<div class="row">
    <?php 
    $formContact = array(
        'name' => 'Contact',
        'label_w' => 'col-sm-5',
        'input_w' => 'col-sm-7',
        'input' =>array()
    );
    echo $this->Formulaire->createForm($formContact);
    ?>
    <div class="col-sm-6">
        <div id="addContactIdent">
            <legend><?php echo  __d('addressbook', 'Contact.fieldset.identity') ?></legend>
                <?php
                $formAddContactIdent = array(
                    'name' => 'Courrier',
                    'label_w' => 'col-sm-5',
                    'input_w' => 'col-sm-7',
                    'input' => array(
                        'Contact.addressbook_id' => array(
                            'inputType' => 'select',
                            'labelText' =>__d('addressbook','Contact.addressbook'),
                            'items'=>array(
                                'type'=>'select',
                                'empty'=>true,
                                'options'=>$addressbooks,
                                'required'=>true
                            )
                        ),
                        'Contact.organisme_id' => array(
                            'inputType' => 'select',
                            'labelText' =>__d('addressbook','Contact.organisme_id'),
                            'items'=>array(
                                'type'=>'select',
                                'empty'=>true,
                                'options'=>$organismes,
                                'required'=>true
                            )
                        ),
                        'Contact.civilite' => array(
                            'labelText' =>__d('addressbook', 'Contact.civilite'),
                            'inputType' => 'select',
                            'items'=>array(
                                'required'=>true,
                                'type'=>'select',
                                'empty' => true, 
                                'options' => $civilite
                            )
                        ),
                        'Contact.nom' => array(
                            'labelText' =>__d('contact', 'Contact.nom'),
                            'inputType' => 'text',
                            'items'=>array(
                                'type'=>'text',
                                'required' => true
                            )
                        ),
                        'Contact.prenom' => array(
                            'labelText' =>__d('contact', 'Contact.prenom'),
                            'inputType' => 'text',
                            'items'=>array(
                                'type'=>'text'
                            )
                        ),
                        'Contact.name' => array(
                            'labelText' =>__d('contact', 'Contact.name'),
                            'inputType' => 'text',
                            'items'=>array(
                                'type'=>'text',
                                'required' => true
                            )
                        )
                    )
                );
                 echo $this->Formulaire->createForm($formAddContactIdent);
                ?>
        </div>
        <div  id="addContactLien">
            <legend><?php echo  __d('addressbook', 'Contactinfo.fieldset.work') ?></legend>
                <?php
                $formAddContactLien = array(
                    'name' => 'Courrier',
                    'label_w' => 'col-sm-5',
                    'input_w' => 'col-sm-7',
                    'input' => array(
                        'Contact.email' => array(
                            'labelText' =>__d('contact', 'Contact.email'),
                            'inputType' => 'email',
                            'items'=>array(
                                'type'=>'email'
                            )
                        ),
                        'Contact.tel' => array(
                            'labelText' =>__d('contact', 'Contact.tel'),
                            'inputType' => 'text',
                            'items'=>array(
                                'type'=>'text'
                            )
                        ),
                        'Contact.portable' => array(
                            'labelText' =>__d('contact', 'Contact.portable'),
                            'inputType' => 'text',
                            'items'=>array(
                                'type'=>'text'
                            )
                        ),
                        'Contact.lignedirecte' => array(
                            'labelText' =>__d('contact', 'Contact.lignedirecte'),
                            'inputType' => 'text',
                            'items'=>array(
                                'type'=>'text'
                            )
                        )
                    )
                );
                if(Configure::read('Conf.SAERP')){
                    $formAddContactLien['input']['Operation.Operation'] = array(
                        'labelText' =>__d('contact', 'Contact.operation_id'),
                        'inputType' => 'select',
                        'items'=>array(
                            'type'=>'select',
                            'empty' => true,
                            'multiple' => true,
                            'options' => $operations
                        )
                    );
                    $formAddContactLien['input']['Event.Event'] = array(
                        'labelText' =>__d('contact', 'Contact.event_id'),
                        'inputType' => 'select',
                        'items'=>array(
                            'type'=>'select',
                            'empty' => true,
                            'multiple' => true,
                            'options' => $events
                        )
                    );
                    $formAddContactLien['input']['Contact.fonction_id'] = array(
                        'labelText' =>__d('contact', 'Contact.fonction_id'),
                            'inputType' => 'select',
                            'items'=>array(
                                'type'=>'select',
                                'empty' => true,
                                'options' => $fonctions
                            )
                    );
                    $formAddContactLien['input']['Contact.observations'] = array(
                        'labelText' =>__d('contact', 'Contact.observations'),
                        'inputType' => 'textarea',
                        'items'=>array(
                            'type'=>'textarea'
                        )
                    );
                }else{
                    $formAddContactLien['input']['Contact.role'] = array(
                        'labelText' =>__d('contact', 'Contact.role'),
                        'inputType' => 'text',
                        'items'=>array(
                            'type'=>'text'
                        )
                    );
                }
                 echo $this->Formulaire->createForm($formAddContactLien);
                ?>
        </div>
    </div>
    <div class="col-sm-6">
        <legend><?php echo __d('contact', 'Contact.adresses') ?></legend>
        <div  id="addContactIdent">
            <?php
            $formAddContactAdd = array(
                'name' => 'Courrier',
                'label_w' => 'col-sm-6',
                'input_w' => 'col-sm-6',
                'input' => array(
                    'Contact.adressecomplete' => array(
                        'labelText' =>__d('contact', 'Contact.adressecompleteLable'),
                        'inputType' => 'text',
                        'items'=>array(
                            'title'=>__d('contact', 'Contact.adressecompleteTitle'),
                            'type'=>'text'
                        )
                    ),
                    'Contact.ban_id' => array(
                        'labelText' =>__d('contact', 'Contact.ban_id'),
                        'inputType' => 'select',
                        'items'=>array(
                            'type'=>'select',
                            'options' => array()
                        )
                    ),
                    'Contact.bancommune_id' => array(
                        'labelText' =>__d('contact', 'Contact.bancommune_id'),
                        'inputType' => 'select',
                        'items'=>array(
                            'type'=>'select',
                            'options' => array()
                        )
                    ),
                    'Contact.banadresse' => array(
                        'labelText' =>__d('contact', 'Contact.banadresse'),
                        'inputType' => 'select',
                        'items'=>array(
                            'type'=>'select',
                            'options' => array()
                        )
                    ),
                    'Contact.numvoie' => array(
                        'labelText' =>__d('contact', 'Contact.numvoie'),
                        'inputType' => 'text',
                        'items'=>array(
                            'type'=>'text'
                        )
                    ),
                    'Contact.nomvoie' => array(
                        'labelText' =>__d('contact', 'Contact.nomvoie'),
                        'inputType' => 'text',
                        'items'=>array(
                            'type'=>'text'
                        )
                    ),
                    'Contact.compl' => array(
                        'labelText' =>__d('contact', 'Contact.compl'),
                        'inputType' => 'text',
                        'items'=>array(
                            'type'=>'text'
                        )
                    ),
                    'Contact.cp' => array(
                        'labelText' =>__d('contact', 'Contact.cp'),
                        'inputType' => 'text',
                        'items'=>array(
                            'type'=>'text'
                        )
                    ),
                    'Contact.ville' => array(
                        'labelText' =>__d('contact', 'Contact.ville'),
                        'inputType' => 'text',
                        'items'=>array(
                            'type'=>'text'
                        )
                    ),
                    'Contact.pays' => array(
                        'labelText' =>__d('contact', 'Contact.pays'),
                        'inputType' => 'text',
                        'items'=>array(
                            'type'=>'text'
                        )
                    )
                )
            );
            echo $this->Formulaire->createForm($formAddContactAdd);
            ?>
        </div>
    </div>
</div>
<script>
    $('#ContactCivilite').select2({allowClear: true, placeholder: "Sélectionner une civilité"});
    $(document).ready(function () {
//        $('#ContactAddressbookId').select2();
        $('#ContactOrganismeId').select2();
        $('#ContactAddressbookId').select2({allowClear: true, placeholder: "Sélectionner un carnet d'adresse"});
    });

    $('#ContactBanId').select2({allowClear: true, placeholder: "Sélectionner un département"});
    $('#ContactBancommuneId').select2({allowClear: true, placeholder: "Sélectionner une commune"});
    $('#ContactBanadresse').select2({allowClear: true, placeholder: "Sélectionner une adresse"});

    <?php if(Configure::read('Conf.SAERP')): ?>
    $('#OperationOperation').select2({allowClear: true, placeholder: "Sélectionner une OP"});
    $('#EventEvent').select2({allowClear: true, placeholder: "Sélectionner un événement"});
    $('#ContactFonctionId').select2({allowClear: true, placeholder: "Sélectionner une fonction"});
    <?php endif;?>

    $('#ContactAddressbookId').change(function () {
        var id = $('#ContactAddressbookId').val();
        $.ajax({
            type: 'post',
            dataType: 'json',
            url: '/Contacts/getOrganismeOption/' + id,
            success: function (data) {
                var options = "<option value=''></option>";
                $.each(data, function (index, value) {
                    options += "<option value='" + index + "'>" + value + "</option>";
                });
                $("#ContactOrganismeId").html(options);
                $('#ContactOrganismeId').select2({allowClear: true, placeholder: "Sélectionner un organisme"});
            }
        });
    });

    $.widget("custom.catcomplete", $.ui.autocomplete, {
        _renderMenu: function (ul, items) {
            var self = this,
                    currentCategory = "";

            $.each(items, function (index, item) {
                if (item.category != currentCategory) {
                    ul.append("<li class='ui-autocomplete-category'>" + item.category + "</li>");
                    currentCategory = item.category;
                }
                self._renderItem(ul, item);
            });

        }

    });


    var bans = [];
    <?php foreach ($bans as $ban) { ?>
    var ban = {
        id: "<?php echo $ban['Ban']['id']; ?>",
        name: "<?php echo $ban['Ban']['name']; ?>",
        banscommunes: []
    };
        <?php foreach ($ban['Bancommune'] as $communeB) { ?>
    var bancommune = {
        id: "<?php echo $communeB['id']; ?>",
        name: "<?php echo $communeB['name']; ?>"
    };
    ban.banscommunes.push(bancommune);
        <?php } ?>
    bans.push(ban);
    <?php } ?>


    function fillBanscommunes(ban_id, bancommune_id) {
        $("#ContactBancommuneId").empty();
        $("#ContactBancommuneId").append($("<option value=''> --- </option>"));

        for (i in bans) {
            if (bans[i].id == ban_id) {
                for (j in bans[i].banscommunes) {
                    if (bans[i].banscommunes[j].id == bancommune_id) {
                        $("#ContactBancommuneId").append($("<option value='" + bans[i].banscommunes[j].id + "' selected='selected'>" + bans[i].banscommunes[j].name + "</option>"));
                    } else {
                        $("#ContactBancommuneId").append($("<option value='" + bans[i].banscommunes[j].id + "'>" + bans[i].banscommunes[j].name + "</option>"));
                    }
                }
            }
        }
    }


    $("#ContactBanId").append($("<option value=''> --- </option>"));
    //remplissage de la liste des types
    for (i in bans) {
        $("#ContactBanId").append($("<option value='" + bans[i].id + "'>" + bans[i].name + "</option>"));
    }
    //definition de l action sur type
    $("#ContactBanId").bind('change', function () {
        var ban_id = $('option:selected', this).attr('value');
        fillBanscommunes(ban_id);
    });

    var checkAdresses = function (bancommune_id) {
        $("#ContactBanadresse").empty();
        $.ajax({
            type: 'post',
            dataType: 'json',
            url: '/Organismes/getAdresses/' + bancommune_id,
            data: $('#ContactAddForm').serialize(),
            success: function (data) {
                if (data.length > 0) {
                    $("#ContactBanadresse").append($("<option value=''> --- </option>"));
                    // remplissage de la partie adresse
                    for (var i in data) {
                        $("#ContactBanadresse").append($("<option value='" + data[i].Banadresse.nom_afnor + "'>" + data[i].Banadresse.nom_afnor + "</option>"));
                    }
                }
            }
        });
    }

    $("#ContactBancommuneId").bind('change', function () {
        var bancommune_id = $('option:selected', this).attr('value');
        checkAdresses(bancommune_id);
    });




    var checkHomonyms = function () {
        $('.homonyms').remove();
        $.ajax({
            type: 'post',
            dataType: 'json',
            url: '/Contacts/getHomonyms',
            data: $('#ContactAddForm').serialize(),
            success: function (data) {

                if (data.length > 0) {
                    var homonyms = $('<div></div>').html('<?php echo __d('contact', 'Contact.HomonymsListTitle'); ?>').addClass('homonyms').addClass('alert alert-warning');
                    var homonymList = $('<ul></ul>');

                    for (var i in data) {
                        homonymList.append($('<li></li>').html(data[i].Contact.name + ' (' + data[i].Addressbook.name + ' / ' + data[i].Organisme.name + ')'));
                    }
                    homonyms.append(homonymList);

                    $('#ContactName').parent().after(homonyms);

                }
            }
        });

    }
    $('#ContactNom, #ContactPrenom').blur(function () {
        if ($('#ContactPrenom').val() != "" || $('#ContactNom').val() != "") {
            $('#ContactName').val($('#ContactPrenom').val() + " " + $('#ContactNom').val());
            checkHomonyms();
        }
    });

    $('#ContactName').change(function () {
        checkHomonyms();
    });
    $('#ContactAddForm').addClass('checkHomonyms');

    // Using jQuery UI's autocomplete widget:
    $('#ContactAdressecomplete').bind("keydown", function (event) {
        //keycodes - maj : 16, ctrl : 17, alt : 18
        if (event.keyCode != 16 &&
                event.keyCode != 17 &&
                event.keyCode != 18) {
            $('#ContactBanId').val(0);
            $('#ContactBancommuneId').html('');
        }
        if ($(this).attr('value') != '') {
            if (event.keyCode === $.ui.keyCode.TAB &&
                    $(this).data("autocomplete").menu.active) {
                event.preventDefault();
            }
        }
    }).catcomplete({
        minLength: 3,
        source: '/contacts/searchAdresse',
        select: function (event, ui) {
            gui.request({
                url: '/contacts/searchAdresseSpecifique/' + ui.item.id
            }, function (data) {
                $('#ContactBancommuneId').val(ui.item.id);
                var json = jQuery.parseJSON(data);
                var banadresse = json['Banadresse'];
                var banville = json['Bancommune'];
                var ban = json['Ban'];
                var num = banadresse['numero'];
                if (typeof banadresse['rep'] !== 'undefined') {
                    num = banadresse['numero'] + " " + banadresse['rep'];
                }
                if (typeof banadresse['id'] !== 'undefined') {
                    $('#ContactBanId').val(ban['id']).change();
                    $('#ContactBancommuneId').val(banville['id']).change();
                    $("#ContactBanadresse").append($("<option value='" + banadresse['nom_afnor'] + "' selected='selected'>" + banadresse['nom_afnor'] + "</option>"));
                    $("#ContactBanadresse").val(banadresse['nom_afnor']).change();
                    $('#ContactNumvoie').val(num);
                    $('#ContactNomvoie').val(banadresse['nom_voie']);
                    $('#ContactCp').val(banadresse['code_post']);
                    $('#ContactVille').val(banville['name']);
                }
            });
        }
    });

    $("#ContactBanId").val("<?php echo isset( $bans[0]['Ban']['id'] ) ? $bans[0]['Ban']['id'] : ''; ?>").change();

    // Partie pour mettre à jour le code postal selon le nom de voie sélectionné
    $('#ContactBanadresse').change(function () {
        refreshCodepostal($("#ContactBancommuneId").val(), $("#ContactBanadresse").val());
    });
    var refreshCodepostal = function (bancommuneId, banadresseName) {
        var params = '';
        if (banadresseName != '') {
            var params = bancommuneId + '/' + banadresseName;
        }
        else {
            params = bancommuneId;
        }
        gui.request({
            url: '/bansadresses/getCodepostal/' + params
        }, function (data) {
            var json = jQuery.parseJSON(data);
            var codepostal = json;
            $('#ContactCp').val(codepostal['codepostal']);
            $('#ContactVille').val(codepostal['ville']);
        });
    }
    <?php if( !empty( $organisme ) ) :?>
    $("#ContactNomvoie").val("<?php echo isset( $organisme['Organisme']['banadresse'] ) ? $organisme['Organisme']['banadresse'] : $organisme['Organisme']['nomvoie'];?>").change();
    $("#ContactNumvoie").val("<?php echo $organisme['Organisme']['numvoie'];?>").change();
    $("#ContactCompl").val("<?php echo $organisme['Organisme']['compl'];?>").change();
    $("#ContactCp").val("<?php echo $organisme['Organisme']['cp'];?>").change();
    $("#ContactVille").val("<?php echo $organisme['Organisme']['ville'];?>").change();
    <?php endif;?>

</script>