<?php

/**
 *
 * Courriers/get_circuit.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<script>
    function set_comment_description_height(etapid, heightComment) {
        $("#comment_description_" + etapid).css('height', heightComment);
        $("#test_" + etapid).css('height', heightComment);
    }
</script>
<?php
if (empty($circuit['Circuit']['id'])) {
    echo $this->Html->tag('div', __d('circuit', 'Circuit.void'), array('class' => 'alert alert-warning'));
} else {
    $typesEtape = array(
        ETAPESIMPLE => 'Simple',
        ETAPEET => 'Collaborative',
        ETAPEOU => 'Concurrente'
    );
    if (empty($visas)) {
?>
<legend><?php echo $circuit['Circuit']['nom']; ?></legend>
<table class="show-circuit" id="circuitGetCircuit">
    <thead ><th class="etapeInfo"></th><th class="arrow"></th><th class="etapeDescription" ></th></thead>
<tbody>
    <?php
        foreach ($etapes as $etape){
            $ulCompoContent = array();
            foreach ($etape['Composition'] as $composition) {
                if( !empty( $composition['Desktopmanager']) ) {
                    
                    // Pour distinguer un desktop du parapheur
                    $compositionName = '';
                    if( $composition['trigger_id'] == '-1') {
                        if( !empty($soustypes) ) {
                            $sousTypeSelectionne = $soustypes[$composition['soustype']];
                            if( !empty( $sousTypeSelectionne )) {
                                $compositionName = 'Etape Parapheur : '.$sousTypeSelectionne;
                            }
                            else {
                                $compositionName = 'Etape Parapheur';
                            }
                        }
                        else {
                            $compositionName = '<i style="color:red;">Etape Parapheur : Connecteur Parapheur en erreur</i>';
                        }
                    }else {
                        $compositionName = $composition[CAKEFLOW_TRIGGER_MODEL][CAKEFLOW_TRIGGER_FIELDS];
                    }
//                    if( $composition['trigger_id'] == '-1') {
//                        $compositionName = 'Etape Parapheur';
//                    }else {
//                        $compositionName = $composition[CAKEFLOW_TRIGGER_MODEL][CAKEFLOW_TRIGGER_FIELDS];
//                    }
                    $ulCompoContent[] = $this->Html->div('desktop_name',$compositionName);
                }
                else {
                    $ulCompoContent[] = $this->Html->div('desktop_name_error', "Aucun bureau n'est associé à cette étape. <br />Veuillez contacter votre administrateur.");
                }
            }
    ?>
    <tr>
        <td class="etapeInfo">
            <div class="panel panel-default" id="comment_<?php echo $etape['Etape']['id']; ?>">
                <div class="panel-heading">
                    <h4 class="panel-title"><?php echo $etape['Etape']['ordre']; ?><span><?php echo $typesEtape[$etape['Etape']['type']]; ?></span></h4>
                </div>
                <div class="panel-body">
                    <legend><?php echo $etape['Etape']['nom']; ?></legend>
                    <ul>
                        <?php foreach ($ulCompoContent as $composition): ?>
                        <li  class="composition"><?php echo $composition; ?></li>
                        <?php endforeach;?>
                    </ul>
                </div>
            </div>
        </td>
        <td class="arrow"><div><div id="test_<?php echo $etape['Etape']['id']; ?>"></div><i class="fa fa-long-arrow-down" aria-hidden="true" ></i></div></td>
        <td class="etapeDescription">
            <div class="panel panel-default " id="comment_description_<?php echo $etape['Etape']['id']; ?>" >
                <div class="panel-body">
                    <legend>Description: </legend>
                    <p><?php echo $etape['Etape']['description']; ?></p>
                </div>
            </div>
        </td>
    </tr>
<script>
    $('.desktop_name_error').css({color: 'red'});
    
    var etapid = "<?php echo $etape['Etape']['id']; ?>";
    $(window).resize(function () {
        var heightComment = $("#comment_" + etapid).height();
        set_comment_description_height(etapid, heightComment);
    });
    var heightComment = $("#comment_" + etapid).height();
    set_comment_description_height(etapid, heightComment);
</script>
    <?php  }//endforeach ?>
</tbody>
</table>
        <?php 
    } else {
?>
<legend><?php echo $circuit['Circuit']['nom']; ?></legend>
<table class="show-circuit" id="circuitGetCircuit">
    <thead ><th class="etapeInfo"></th><th class="arrow"></th><th class="etapeDescription"></th></thead>
<tbody>
    <?php 
        $chkValid = '<i class="fa fa-check" aria-hidden="true" style="color:#3C765A"></i>';
        $refusImg = '<i class="fa fa-times-o" aria-hidden="true" style="color:#A94464"></i>';
        $convertVisaAction = array(
            'RI' => '',
            'OK' => $chkValid,
            'KO' => $refusImg,
            'IL' => $chkValid,
            'IP' => $chkValid,
            'JP' => '',
            'JS' => '',
            'ST' => '',
            'IN' => ''
        );
        $numTraitementAct = $visas[0]['Traitement']['numero_traitement'];
        $isTreatedTraitementAct = $visas[0]['Traitement']['treated'];
        
        $inserted = false;
        $cptInserted = 0;
        foreach ($visas as $i => $visa){ 
            
            if ($visa['Visa']['numero_traitement'] < $numTraitementAct || $isTreatedTraitementAct) {
                $specialClassEtape = ' panel-success';
                $descriptionEtapeTitle = 'Etape validée';
                $arrowDirectionColor = '#B6CDA2';
            } else if ($visa['Visa']['numero_traitement'] == $numTraitementAct) {
                $specialClassEtape = ' panel-danger';
                $descriptionEtapeTitle = 'Etape en cours';
                $arrowDirectionColor = '#A94464';
            } else if ($visa['Visa']['numero_traitement'] > $numTraitementAct) {
                $specialClassEtape = ' panel-default';
                $descriptionEtapeTitle = 'Etape non traiter';
                $arrowDirectionColor = '#b2b2b2';
            }
            
            //preparation de l'affichage des étapes insérées
            $specialClassEtapeInserted="";
            if ($inserted && $cptInserted > 1) {
                    $cptInserted--;
                    $specialClassEtapeInserted .= 'etape-insert';
            } else if ($inserted && $cptInserted == 1) {
                    $cptInserted = 0;
                    $inserted = false;
                    $specialClassEtapeInserted .= 'etape-insert';
            }
        
            $ulCompoContent = array();
            foreach ($visa['Composition'] as $composition) {
                if ($composition[CAKEFLOW_TRIGGER_MODEL]['action'] == 'IL') {
                    $inserted = true;
                    $cptInserted = 2;
                } else if ($composition[CAKEFLOW_TRIGGER_MODEL]['action'] == 'IP') {
                    $inserted = true;
                    $cptInserted = 1;
                }
                // Si l'étape est de type parapheur (le nom du bureau est vide) alors on inscrit Etape Parapheur
                if(!empty( $composition[CAKEFLOW_TRIGGER_MODEL][CAKEFLOW_TRIGGER_FIELDS] )) {
                    $ulCompoContent[] = $convertVisaAction[$composition[CAKEFLOW_TRIGGER_MODEL]['action']] . ' ' . $this->Html->div('desktop_name',$composition[CAKEFLOW_TRIGGER_MODEL]['name']);
                }
                else {
                    $ulCompoContent[] = $convertVisaAction[$composition[CAKEFLOW_TRIGGER_MODEL]['action']] . ' Etape Parapheur';
                }
            }
    ?>

    <tr title="<?php echo $descriptionEtapeTitle; ?>"  >
        <td class="etapeInfo <?php echo $specialClassEtapeInserted; ?>" >
            <div class="panel <?php echo $specialClassEtape; ?>" id="comment_<?php echo $visa['Etape']['id']; ?>">
                <div class="panel-heading">
                    <h4 class="panel-title"><?php echo $visa['Visa']['numero_traitement']; ?><span><?php echo $typesEtape[$visa['Visa']['etape_type']]; ?></span></h4>
                </div>
                <div class="panel-body">
                    <legend><?php echo $visa['Visa']['etape_nom']; ?></legend>
                    <ul>
                        <?php foreach ($ulCompoContent as $composition): ?>
                        <li class="composition"><?php echo $composition; ?></li>
                        <?php endforeach;?>
                    </ul>
                </div>
            </div>
        </td>
        <td class="arrow" style="color:<?php echo $arrowDirectionColor; ?>; "><div ><div style="background:<?php echo $arrowDirectionColor; ?>;" id="test_<?php echo $visa['Etape']['id']; ?>"></div><i class="fa fa-long-arrow-down" aria-hidden="true" ></i></div></td>
        <td class="etapeDescription">
            <div class="panel panel-default " id="comment_description_<?php echo $visa['Etape']['id']; ?>" style="border-color:<?php echo $arrowDirectionColor; ?>; ">
                <div class="panel-body">
                    <legend>Description: </legend>
                    <p><?php echo $visa['Etape']['description']; ?></p>
                </div>
            </div>
        </td>
    </tr>
<script>
    
    var etapid = "<?php echo $visa['Etape']['id']; ?>";
    $(window).resize(function () {
        var heightComment = $("#comment_" + etapid).height();
        set_comment_description_height(etapid, heightComment);
    });
    var heightComment = $("#comment_" + etapid).height();
    set_comment_description_height(etapid, heightComment);
</script>
    <?php } ?>
</tbody>
</table>
<?php 
    }  
}
?>