<?php

/**
 *
 * Elements/ctxdoc.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php
$typeMime = array(
    'application/vnd.ms-office' => array(
        'ico' => '/img/document.png',
        'name' => 'Document MS Office'
    ),
    'application/vnd.oasis.opendocument.text' => array(
        'ico' => '/img/document.png',
        'name' => 'Document ODT'
    ),
    'VND.OASIS.OPENDOCUMENT.TEXT' => array(
        'ico' => '/img/document.png',
        'name' => 'Document ODT'
    ),
    'OCTET-STREAM' => array(
        'ico' => '/img/document.png',
        'name' => 'Document ODT'
    ),
    'application/rtf' => array(
        'ico' => '/img/document.png',
        'name' => 'Document RTF'
    ),
    'application/msword' => array(
        'ico' => '/img/document.png',
        'name' => 'Document MS Word'
    ),
    'text/plain' => array(
        'ico' => '/img/document.png',
        'name' => 'Document texte'
    ),
    'application/pdf' => array(
        'ico' => '/img/pdf.png',
        'name' => 'Document PDF'
    ),
    'PDF' => array(
        'ico' => '/img/pdf.png',
        'name' => 'Document PDF'
    ),
    'image/gif' => array(
        'ico' => '/img/image.png',
        'name' => 'Image GIF'
    ),
    'image/png' => array(
        'ico' => '/img/image.png',
        'name' => 'Image PNG'
    ),
    'image/jpeg' => array(
        'ico' => '/img/image.png',
        'name' => 'Image JPEG'
    ),
    'audio/x-wav' => array(
        'ico' => '/img/audio.png',
        'name' => 'Fichier audio WAV'
    ),
    'audio/wav' => array(
        'ico' => '/img/audio.png',
        'name' => 'Fichier audio WAV'
    ),
    'audio/mp3' => array(
        'ico' => '/img/audio.png',
        'name' => 'Fichier audio MP3'
    ),
    'audio/ogg' => array(
        'ico' => '/img/audio.png',
        'name' => 'Fichier audio OGG'
    ),
    'audio/mpeg' => array(
        'ico' => '/img/audio.png',
        'name' => 'Fichier audio MPEG/MP3'
    ),
    'video/mp4' => array(
        'ico' => '/img/video.png',
        'name' => 'Fichier video MPEG 4'
    ),
    'application/ogg' => array(
        'ico' => '/img/video.png',
        'name' => 'Fichier video OGG'
    ),
    'video/ogg' => array(
        'ico' => '/img/video.png',
        'name' => 'Fichier video OGG'
    ),
    'video/mpg' => array(
        'ico' => '/img/video.png',
        'name' => 'Fichier video MPEG'
    ),
    'video/mpeg' => array(
        'ico' => '/img/video.png',
        'name' => 'Fichier video MPEG'
    ),
    'unknown' => array(
        'ico' => '/img/unknown-mime.png',
        'name' => 'Type de fichier inconnu'
    ),
    'application/vnd.oasis.opendocument.text' => array(
        'ico' => '/img/ooo_writer_22.png',
        'name' => 'Fichier OpenOffice Writer'
    ),
    'application/vnd.oasis.opendocument.spreadsheet' => array(
        'ico' => '/img/ooo_calc.png',
        'name' => 'Fichier Calc/Excel'
    ),
    'application/force-download' => array(
        'ico' => '/img/document.png',
        'name' => 'Document ODT'
    ),
);

$aricons = array(
    'audio' => '/img/audio.png',
    'video' => '/img/video.png',
    'ott' => '/img/document.png',
    'email' => '/img/email.png',
    'sms' => '/img/phone.png'
);

if (!isset($adminMode)) {
    $adminMode = false;
}

if (!isset($selectableForMainDoc)) {
    $selectableForMainDoc = false;
}

if( !isset( $rightToDelete ) ) {
    $rightToDelete = false;
}

if (count($ctxdoc) > 1) {
?>
<div model="<?php echo $gfcDocType; ?>" controllerName="<?php echo $gfcDocType . "s"; ?>" itemId="<?php echo $ctxdoc['id']; ?>" class="<?php echo!empty($cssClass) ? $cssClass : ''; ?>" style="line-height:35px;" id="<?php echo $gfcDocType; ?>_<?php echo $ctxdoc['id']; ?>">
    <span class="ctxdoc_name">
        <?php
        if ($gfcDocType == "Armodel") {
            echo $this->Html->image($aricons[$ctxdoc['format']], array('title' => !empty($ctxdoc['mime']) ? $typeMime[$ctxdoc['mime']]['name'] : '')) . ' ';
        } else {
            if (!empty($ctxdoc['mime'])) {
                if (!in_array($ctxdoc['mime'], array_keys($typeMime))) {
                    echo $this->Html->image($typeMime['unknown']['ico'], array('title' => $typeMime['unknown']['name'])) . ' ';
                } else {
                    echo $this->Html->image($typeMime[$ctxdoc['mime']]['ico'], array('title' => $typeMime[$ctxdoc['mime']]['name'])) . ' ';
                }
            } else {
                echo $this->Html->image('/img/document.png') . ' ';
//                echo '<i class="fa fa-file-pdf-o table" title="Documents"></i>';
            }
        }
//        echo $this->Html->tag('span', $ctxdoc['name'], array('class' => 'filename')) . (!empty($ctxdoc['size']) ? ' (' . $this->Html2->formatsize($ctxdoc['size']) . ')' : '');
        if( Configure::read('debug') == 2 ) {
            echo $this->Html->tag('span', mb_strimwidth($ctxdoc['name'], 0, 35, "..."), array('class' => 'filename', 'title' => $ctxdoc['name']) ) . (!empty($ctxdoc['size']) ? ' (' . $this->Html2->formatsize($ctxdoc['size']) . ')' : '');
        }
        else {
            echo $this->Html->tag('span', mb_strimwidth($ctxdoc['name'], 0, 35, "..."), array('class' => 'filename', 'title' => $ctxdoc['name']));// . (!empty($ctxdoc['size']) ? ' (' . $this->Html2->formatsize($ctxdoc['size']) . ')' : '');
        }
        
        ?>
    </span>
    <span class="ctxdoc_actions " role="group" style="float:right;">
        <?php
        if ($selectableForMainDoc && $right_setAsDefault && ( $this->action != 'getParent' ) ) {
//            $img = $this->Html->image('/img/file.gif', array('alt' => 'principal', 'title' => 'Définir comme document principal', 'class' => 'ctxdocBttnSetMainDoc'));
            $img = $this->Html->tag('i', '', array('class' => 'fa fa-file fa-fw ctxdocBttnSetMainDoc', 'aria-hidden'=>true));
            echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ','title' => 'Définir comme document principal'));
        }

        if (!empty($ctxdoc['size']) && $ctxdoc['size'] > 0  ) {
//            $img = $this->Html->image('/img/download_32.png', array('alt' => 'télécharger', 'title' => 'Télécharger le fichier', 'class' => 'ctxdocBttnDownload'));
            $img = $this->Html->tag('i','',array('class'=>'fa fa-download fa-fw ctxdocBttnDownload','aria-hidden'=>true));
//            echo $this->Html->link($img, '/' . $gfcDocType . 's/download/' . $ctxdoc['id'], array('escape' => false,'class'=>' btn btn-default '));
            if( $gfcDocType == "Gabaritdocument" ) {
                echo $this->Html->link($img, '/gabaritsdocuments/download/' . $ctxdoc['id'], array('escape' => false,'class'=>' btn btn-default ','title' => 'Télécharger le fichier'));
            }
            else {
                echo $this->Html->link($img, '/' . $gfcDocType . 's/download/' . $ctxdoc['id'], array('escape' => false,'class'=>' btn btn-default ','title' => 'Télécharger le fichier'));
            }
        }
//debug($ctxdoc);
        if ($gfcDocType == 'Relement' || $gfcDocType == 'Document' && in_array( $ctxdoc['mime'], array( 'application/vnd.oasis.opendocument.text' ) ) && $ctxdoc['isgenerated'] == true ) {
            if(empty($ctxdoc['id']) && !empty($ctxdoc['name'])) {
                 $img = $this->Html->tag('i','', array('class' => 'fa fa-plus-circle fa-fw ctxdocBttnWebdavAdd', 'itemName' => $ctxdoc['name']));
                 echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ','title' => 'Utiliser ce fichier (webdav)'));
            }
            else {
                 $img = $this->Html->tag('i', '',array( 'class' => 'fa fa-pencil fa-fw ctxdocBttnWebdav','aria-hidden'=>true,'itemName' => $ctxdoc['name']));
                 echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ','title' => 'Editer le fichier (webdav)'));
            }
        }

        if (!$adminMode && ( $this->action != 'getParent' ) ) {
            if ($gfcDocType == 'Document'  ) {
                if(isset($ctxdoc['path'])){
//                    $fileName = $ctxdoc['name'];
                    $fileName =  substr( $ctxdoc['name'], 0, 7 ).'...';
//                    $img = $this->Html->image('/img/fileview-preview.png', array('alt' => 'visualisation', 'title' => 'Visualiser le fichier', 'class' => 'ctxdocBttnPreviewRelements','fileName'=>$fileName));
                    $img = $this->Html->tag('i','',array('class'=>'fa fa-eye fa-fw ctxdocBttnPreviewRelements','aria-hidden'=>true,'fileName'=>$fileName));
                    echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ','title' => 'Visualiser le fichier'));
                }else{
//                    $img = $this->Html->image('/img/fileview-preview.png', array('alt' => 'visualisation', 'title' => 'Visualiser le fichier', 'class' => 'ctxdocBttnPreview'));
                    $img = $this->Html->tag('i','',array('class'=>'fa fa-eye fa-fw ctxdocBttnPreview','aria-hidden'=>true));
                    echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ','title' => 'Visualiser le fichier'));
                }
            }
            if($gfcDocType == 'Armodel') {
//                $img = $this->Html->image('/img/fileview-preview.png', array('alt' => 'visualisation', 'title' => 'Visualiser le fichier', 'class' => 'ctxdocBttnPreviewArmodel'));
                $img = $this->Html->tag('i','',array('class'=>'fa fa-eye fa-fw ctxdocBttnPreviewArmodel','aria-hidden'=>true));
                echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ','title' => 'Visualiser le fichier'));
            }
            if($gfcDocType == 'Ar') {
//                $img = $this->Html->image('/img/fileview-preview.png', array('alt' => 'visualisation', 'title' => 'Visualiser le fichier', 'class' => 'ctxdocBttnPreviewAr'));
                $img = $this->Html->tag('i','',array('class'=>'fa fa-eye fa-fw ctxdocBttnPreviewAr','aria-hidden'=>true));
                echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ','title' => 'Visualiser le fichier'));
            }
            if($gfcDocType == 'Rmodel') {
//                $img = $this->Html->image('/img/fileview-preview.png', array('alt' => 'visualisation', 'title' => 'Visualiser le fichier', 'class' => 'ctxdocBttnPreviewRmodel'));
                $img = $this->Html->tag('i','',array('class'=>'fa fa-eye fa-fw ctxdocBttnPreviewRmodel','aria-hidden'=>true));
                echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ','title' => 'Visualiser le fichier'));
            }
        }

        if( $gfcDocType == 'Document' && $ctxdoc['mime'] != 'application/pdf' && $ctxdoc['ext'] != 'zip') {
//            $img = $this->Html->image('/img/pdf.png', array('alt' => 'conversion', 'title' => 'Convertir en PDF', 'class' => 'ctxdocBttnConversionPDF'));
            $img = $this->Html->tag('i', '',array( 'class' => 'fa fa-file-pdf-o fa-fw ctxdocBttnConversionPDF','aria-hidden'=>true));
            echo $this->Html->link($img, '/Documents/convertToPdf/' . $ctxdoc['id'], array('escape' => false,'class'=>' btn btn-default ','title' => 'Convertir en PDF'));
        }
        
        if (
            ($adminMode && $gfcDocType == "Rmodel") ||
            ($adminMode && $gfcDocType == "Armodel") ||
            (!$adminMode && $gfcDocType != "Armodel" && $gfcDocType != "Rmodel")
        ) {

            if( $gfcDocType == "Ar" && in_array( $ctxdoc['mime'], array( 'application/vnd.oasis.opendocument.text' ) ) ) {
                $img = $this->Html->tag('i', '',array( 'class' => 'fa fa-pencil fa-fw ctxdocBttnWebdav','aria-hidden'=>true,'itemName' => $ctxdoc['name']));
                echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ', 'title' => 'Editer le fichier (webdav)'));
                    
//                $img = $this->Html->image('/img/pdf.png', array('alt' => 'conversion', 'title' => 'Convertir en PDF', 'class' => 'ctxdocBttnConversionPDF'));
                $img = $this->Html->tag('i', '',array( 'class' => 'fa fa-file-pdf-o fa-fw ctxdocBttnConversionPDF','aria-hidden'=>true));
                echo $this->Html->link($img, '/Ars/convertToPdf/' . $ctxdoc['id'], array('escape' => false,'class'=>' btn btn-default ','title' => 'Convertir en PDF'));
            }

            if (!empty($right_delete) || $adminMode || $rightToDelete) {
//                $img = $this->Html->image('/img/delete_16.png', array('alt' => 'supprimer', 'title' => 'Supprimer le fichier', 'class' => 'ctxdocBttnDelete'));
                $img = $this->Html->tag('i','', array( 'class' => 'ctxdocBttnDelete fa fa-trash fa-fw','aria-hidden'=>true));
                echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ', 'title' => 'Supprimer le fichier'));
            }
                
                // Ajout de l'envoi individuel d'un document par mail
            if((isset($sendCourrier) && $sendCourrier) || !isset($sendCourrier)){
                if (!empty($right_sendmail) || $adminMode ) {
                    if($gfcDocType != 'Relement') {
    //                $img = $this->Html->image('/img/email.png', array('alt' => 'Envoyer par mail', 'title' => 'Envoyer le document par mail', 'class' => 'ctxdocBttnSendmail'));
                        $img = $this->Html->tag('i','', array('class' => 'ctxdocBttnSendmail fa fa-paper-plane fa-fw','aria-hidden'=>true));
                        echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ','title' => 'Envoyer le document par mail', ));
                    }
                }
            }
            
                // Ajout de l'envoi individuel d'un document par mail
            if((isset($sendGED) && $sendGED) || !isset($sendGED)){
                if (!empty($right_sendged) || $adminMode) {
//                $img = $this->Html->image('/img/folder_sent_mail_16.png', array('alt' => 'Verser en GED', 'title' => 'Versement du document en GED', 'class' => 'ctxdocBttnSendDocged'));
                    $img = $this->Html->tag('i','', array('class' => 'ctxdocBttnSendDocged fa fa-share-square-o','aria-hidden'=>true));
                    echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ','title' => 'Versement du document en GED'));
                }
            }
        }
            
        if (($adminMode && $gfcDocType == "Rmodelgabarit")) {

            if (!empty($right_delete) || $adminMode || $rightToDelete ) {
//                $img = $this->Html->image('/img/delete_16.png', array('alt' => 'supprimer', 'title' => 'Supprimer le fichier', 'class' => 'ctxdocBttnDeleteGabarit'));
                $img = $this->Html->tag('i','', array( 'class' => 'ctxdocBttnDeleteGabarit fa fa-trash fa-fw','aria-hidden'=>true));
                echo $this->Html->link($img, '#', array('escape' => false,'class'=>' btn btn-default ', 'title' => 'Supprimer le fichier'));
            }

        }
        if ($adminMode && $gfcDocType == "Gabaritdocument" ) {
	 	 	
            if (!empty($right_delete) || $adminMode || $rightToDelete ) {
//                echo $this->Html->image('/img/delete_16.png', array('alt' => 'supprimer', 'title' => 'Supprimer le fichier', 'class' => 'ctxdocBttnDeleteGabaritdocument'));
                echo  $this->Html->tag('i','', array( 'class' => 'ctxdocBttnDeleteGabaritdocument fa fa-trash fa-fw','aria-hidden'=>true,'title' => 'Supprimer le fichier'));
            }

        }
?>
    </span>


</div>
<?php
} else {
//    echo $ctxdoc['name'];
    echo substr( $ctxdoc['name'], 0, 7 ).'...';
}
?>

<?php if( isset( $ctxdoc['courrier_id'] ) && !empty($ctxdoc['courrier_id']) ):?>
<script type="text/javascript">
    $('.document_list .ctxdocBttnWebdav').unbind('click').click(function () {
        window.location.href = "<?php echo WEBDAV_URL; ?>" + "/" + "<?php echo $ctxdoc['courrier_id']; ?>" + "/" + $(this).attr('itemname');
    });
    $('.main_document .ctxdocBttnWebdav').unbind('click').click(function () {
        window.location.href = "<?php echo WEBDAV_URL; ?>" + "/" + "<?php echo $ctxdoc['courrier_id']; ?>" + "/" + $(this).attr('itemname');
    });
    $('.panel-body .ctxdocBttnWebdav').unbind('click').click(function () {
        window.location.href = "<?php echo WEBDAV_URL; ?>" + "/" + "<?php echo $ctxdoc['courrier_id']; ?>" + "/" + $(this).attr('itemname');
    });
    $('#arElement .ctxdocBttnWebdav').unbind('click').click(function () {
        window.location.href = "<?php echo WEBDAV_URL; ?>" + "/" + "<?php echo $ctxdoc['courrier_id']; ?>" + "/" + $(this).attr('itemname');
    });
</script>
<?php endif;?>