<?php

/**
 *
 * Soustypes/add.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php 
echo $this->Html->script('formValidate.js', array('inline' => true));
?>

<div id="stype_tabs">
    <ul  class="nav nav-tabs titre" role="tablist">
        <li class="active" ><a href="#stype_tabs_1" role="tab" data-toggle="tab"><?php echo __d('default', 'Informations'); ?></a></li>
        <li><a href="#stype_tabs_2" role="tab" data-toggle="tab"><?php echo __d('soustype', 'Soustype.Armodels'); ?></a></li>
        <li><a href="#stype_tabs_3" role="tab" data-toggle="tab"><?php echo __d('soustype', 'Soustype.Rmodels'); ?></a></li>
    </ul>
    <div class="tab-content"> 
        <div id="stype_tabs_1" class="tab-pane fade active in">
                        <?php
                            $formSoustype = array(
                                'name' => 'Soustype',
                                'label_w' => 'col-sm-5',
                                'input_w' => 'col-sm-6',
                                'form_url' => array('controller' => 'Soustypes', 'action' => 'add', $type_id),
                                'input' => array(
                                    'Soustype.name' => array(
                                        'labelText' =>__d('soustype', 'Soustype.name'),
                                        'labelPlaceholder' => __d('soustype', 'Soustype.placeholderNameAdd'),
                                        'inputType' => 'text',
                                        'items'=>array(
                                            'required'=>true,
                                            'type'=>'text'
                                        )
                                    ),
                                    'Soustype.type_id' => array(
                                        'labelText' =>__d('soustype', 'Soustype.type_id'),
                                        'inputType' => 'select',
                                        'items'=>array(
                                            'type'=>'select',
                                            'options' => $types, 
                                            'empty' => true,
                                            'required'=>true
                                        )
                                    ),
                                    'Soustype.circuit_id' => array(
                                        'labelText' =>__d('soustype', 'Soustype.circuit_id'),
                                        'inputType' => 'select',
                                        'items'=>array(
                                            'type'=>'select',
                                            'options' => $circuits, 
                                            'empty' => true
                                        )
                                    ),
                                    'Soustype.information' => array(
                                        'labelText' =>__d('soustype', 'Soustype.information'),
                                        'inputType' => 'text',
                                        'items'=>array(
                                            'type'=>'text'
                                        )
                                    ),
                                    'Metadonnee.Metadonnee' => array(
                                        'labelText' =>__d('soustype', 'Metadonnee.Metadonnee'),
                                        'inputType' => 'select',
                                        'items'=>array(
                                            'type'=>'select',
                                            'multiple' => true, 
                                            'options' => $listMeta
                                        )
                                    )
                                )
                            );
                        echo $this->Formulaire->createForm($formSoustype);
                        ?>
            <div class="col-sm-6">
                <legend><?php echo __d('soustype', 'Soustype.delai'); ?></legend>
                    <?php
                    $formSoustypeDelai = array(
                                'name' => 'Soustype',
                                'label_w' => 'col-sm-5',
                                'input_w' => 'col-sm-6',
                                'form_url' => array('controller' => 'Soustypes', 'action' => 'add', $type_id),
                                'input' => array(
                                    'Soustype.delai_nb' => array(
                                        'labelText' =>__d('soustype', 'Soustype.delai_nb'),
                                        'inputType' => 'number',
                                        'items'=>array(
                                            'type'=>'number'
                                        )
                                    ),
                                    'Soustype.delai_unite' => array(
                                        'labelText' =>__d('soustype', 'Soustype.delai_unite'),
                                        'inputType' => 'select',
                                        'items'=>array(
                                            'type'=>'select',
                                            'options' =>array('0' => 'jour', '1' => 'semaine', '2' => 'mois'), 
                                            'empty' => true
                                        )
                                    )
                                )
                            );
                        echo $this->Formulaire->createForm($formSoustypeDelai);
                    ?>
            </div>
            <div class="col-sm-6">
                <legend><?php echo __d('soustype', 'Soustype.entrant'); ?></legend>
                                <?php
                                $formSoustypeEntrant = array(
                                    'name' => 'Soustype',
                                    'label_w' => 'col-sm-6',
                                    'input_w' => 'col-sm-6',
                                    'form_url' => array('controller' => 'Soustypes', 'action' => 'add', $type_id),
                                    'input' => array(
                                        'Soustype.entrant' => array(
                                            'labelText' =>__d('soustype', 'Soustype.name'),
                                            'labelPlaceholder' => __d('soustype', 'Soustype.delai_nb'),
                                            'inputType' => 'radio',
                                            'items'=>array(
                                                'legend' => false,
                                                'separator'=> '</div><div  class="radioUserGedLabel">',
                                                'before' => '<div class="radioUserGedLabel">',
                                                'after' => '</div>',
                                                'label' => true,
                                                'type'=>'radio',
                                                'required'=>true,
                                                'options'=> array(
                                                    1 => __d('soustype', 'Soustype.entrant.entrant'), 
                                                    0 => __d('soustype', 'Soustype.entrant.sortant'),
                                                    2 => __d('soustype', 'Soustype.entrant.interne')
                                                ),
                                            )
                                        ),
                                        'Soustype.parent_id' => array(
                                            'labelText' =>__d('soustype', 'Soustype.parent_id'),
                                            'inputType' => 'select',
                                            'items'=>array(
                                                'type'=>'select',
                                                'options' => $soustypesList, 
                                                'empty' => true, 
                                                'disabled' => 'disabled'
                                            )
                                        )
                                    )
                                );
                                echo $this->Formulaire->createForm($formSoustypeEntrant);
                                ?>
            </div>
        </div>
        <div  class="tab-pane fade"  id="stype_tabs_2">
            <div class="alert alert-warning"><?php echo __d('soustype', 'Soustype.Armodels.undefined'); ?></div>
        </div>
        <div  class="tab-pane fade" id="stype_tabs_3">
            <div class="alert alert-warning"><?php echo __d('soustype', 'Soustype.Rmodels.undefined'); ?></div>
        </div>
    </div>    
</div>

<script type="text/javascript">
    
    function InsertSelectedValueIntoInput(el) {
        var input = $('input[type=text]:first', $(el).parent());
        var caretPos = $(input).caret().start;

        var newVal = $("option:selected", el).val();
        var beginVal = input.val().substr(0, caretPos);
        var endVal = input.val().substr(caretPos, input.val().length);

        input.val(beginVal + newVal + endVal);
    }

    function defRefInOut() {
        var inRef = "E_";
        var outRef = "S_";
        var internalRef = "I_";
        if ($('#SoustypeEntrant1').prop("checked")) {
            $('#refInOut').html(inRef);
        } else if ($('#SoustypeEntrant0').prop("checked")) {
            $('#refInOut').html(outRef);
        } else if ($('#SoustypeEntrant2').prop("checked")) {
            $('#refInOut').html(internalRef);
        }
    }
    $("<span class='formatNomSoustype alert alert-warning col-sm-11'><?php echo __d('soustype', 'Soustype.formatNameAdd'); ?></span>").insertAfter($('#SoustypeName').parents('.form-group'));

    $('#SoustypeName').blur(function () {
        var test = $('#SoustypeName').val();
        var string = test.split('- Flux');
        var type = $("input[name='data[Soustype][entrant]']:checked").val();
        if (type == 1) {
            $('#SoustypeName').val(string[0] + '- Flux Entrants');
        } else if (type == 2) {
            $('#SoustypeName').val(string[0] + '- Flux Internes');
        } else {
            $('#SoustypeName').val(string[0] + '- Flux Sortants');
        }
    });

//        $('#SoustypeParentId').hide();
    $('label[for="SoustypeParentId"]').parent().hide();
    $('#SoustypeEntrant0').change(function () {
        $('#SoustypeParentId').select2();
        $('label[for="SoustypeParentId"]').parent().show();
        $('#SoustypeParentId').removeAttr('disabled');
        var test = $('#SoustypeName').val();
        var string = test.split('- Flux');
//                $('#SoustypeParentId').select2();
        $('#SoustypeName').val(string[0] + '- Flux Sortants');

        defRefInOut();
    });
    $('#SoustypeEntrant1').change(function () {
        if ($('#SoustypeEntrant1').prop("checked")) {
            //$('#SoustypeParentId').attr('disabled', "disabled");
//            $('#SoustypeParentId').hide();
            $('label[for="SoustypeParentId"]').parent().hide();
            var test = $('#SoustypeName').val();
            var string = test.split('- Flux');
            $('#SoustypeName').val(string[0] + '- Flux Entrants');
            defRefInOut();
        }
    });
    $('#SoustypeEntrant2').change(function () {
        if ($('#SoustypeEntrant2').prop("checked")) {
            //$('#SoustypeParentId').attr('disabled', "disabled");
//            $('#SoustypeParentId').hide();
            $('label[for="SoustypeParentId"]').parent().hide();
            var test = $('#SoustypeName').val();
            var string = test.split('- Flux');
            $('#SoustypeName').val(string[0] + '- Flux Internes');
            defRefInOut();
        }
    });

    defRefInOut();

    $(document).ready(function () {
        $('#MetadonneeMetadonnee').select2();

        $('#SoustypeTypeId').select2();
        $('#SoustypeCircuitId').select2();
        $('#SoustypeDelaiUnite').select2();
    });

</script>