<?php

/**
 *
 * Soustypes/index.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php
//echo $this->Html->css(array('administration'), null, array('inline' => false)); 
?>

<script type="text/javascript">
    function loadTypesSoutypes() {
        $('#infos .content').empty();
        gui.request({
            url: "<?php echo Configure::read('BaseUrl') . "/soustypes/getTypesSoustypes"; ?>",
            updateElement: $('#liste .content'),
            loader: true,
            loaderMessage: gui.loaderMessage
        });
    }
</script>


<div class="container">
    <div id="liste" class="row">
        <div  class="table-list">
            <h3><?php echo __d('soustype', 'Soustype.liste'); ?><span class="action-title " role="group"></span></h3>
            <div class="content">

            </div>

        </div>
        <div class="controls panel-footer " role="group">

        </div>
    </div>
</div>

<div id="infos" class="modal fade" role="dialog">
    <div class="modal-dialog  modal-lg">
        <!-- Modal content-->
        <div class="modal-content">
            <div class="panel">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h4 class="panel-title"><?php echo __d('soustype', 'Soustype.infos'); ?></h4>
                    </div>
                    <div class="panel-body content">

                    </div>
                    <div class="panel-footer controls " role="group">

                    </div>
                </div>
            </div>
        </div>

    </div>
</div>



<script type="text/javascript">
    gui.buttonbox({
        element: $('#liste .controls')
    });

    gui.addbutton({
        element: $('#liste .table-list h3 .action-title'),
        button: {
            content: '<i class="fa fa-plus-circle" aria-hidden="true"></i> <?php echo __d("type", "New Type"); ?>',
            "class": "btn btn-primary ",
            action: function () {
                $('#infos').modal('show');
                gui.request({
                    url: "<?php echo Configure::read('BaseUrl') . "/Types/add"; ?>",
                    updateElement: $('#infos .content'),
                    loader: true,
                    loaderMessage: gui.loaderMessage
                });
            }
        }
    });

    gui.addbutton({
        element: $('#liste .controls'),
        button: {
            content: '<i class="fa fa-plus-circle" aria-hidden="true"></i> <?php echo __d("type", "New Type"); ?>',
            class: "btn-info-webgfc  ",
            action: function () {
                $('#infos').modal('show');
                gui.request({
                    url: "<?php echo Configure::read('BaseUrl') . "/Types/add"; ?>",
                    updateElement: $('#infos .content'),
                    loader: true,
                    loaderMessage: gui.loaderMessage
                });
            }
        }
    });

    gui.addbutton({
        element: $('#liste .controls'),
        button: {
            content: '<i class="fa fa-plus-circle" aria-hidden="true"></i> <?php echo __d("soustype", "New Soustype"); ?>',
            class: "btn-info-webgfc  ",
            action: function () {
                $('#infos').modal('show');
                gui.request({
                    url: "<?php echo Configure::read('BaseUrl') . "/Soustypes/add"; ?>",
                    updateElement: $('#infos .content'),
                    loader: true,
                    loaderMessage: gui.loaderMessage
                });
            }
        }
    });

    gui.addbutton({
        element: $('#liste .table-list h3 .action-title'),
        button: {
            content: '<i class="fa fa-plus-circle" aria-hidden="true"></i> <?php echo __d("soustype", "New Soustype"); ?>',
            'class': "btn btn-primary ",
            action: function () {
                $('#infos').modal('show');
                gui.request({
                    url: "<?php echo Configure::read('BaseUrl') . "/Soustypes/add"; ?>",
                    updateElement: $('#infos .content'),
                    loader: true,
                    loaderMessage: gui.loaderMessage
                });
            }
        }
    });

    gui.buttonbox({
        element: $('#infos .controls'),
        align: "center"
    });

    gui.addbuttons({
        element: $('#infos .controls'),
        buttons: [
            {
                content: "<?php echo __d('default', 'Button.submit'); ?>",
                class: "btn-success ",
                action: function () {
                    var forms = $(this).parents('.modal').find('form');
                    $.each(forms, function (index, form) {
                        var url = form.action;
                        var id = form.id;
                        if (form_validate($('#' + id))) {
                            var radioPass = false;
                            $('input[id^="SoustypeEntrant"]').each(function () {
                                if ($(this).is(':checked')) {
                                    radioPass = true;
                                }
                            });
                            if (id != "SoustypeAddForm" && id != "SoustypeEditForm") {
                                radioPass = true;
                            }
                            if (radioPass) {
                                gui.request({
                                    url: url,
                                    data: $('#' + id).serialize()
                                }, function (data) {
                                    getJsonResponse(data);
                                    loadTypesSoutypes();
                                });
                                $(this).parents('.modal').modal('hide');
                            } else {
                                swal({
                                    title: "Oops...",
                                    text: "Veuillez vérifier choisir votre sens des flux!",
                                    type: "error",
                                    timer: 1500
                                });
                            }
                        } else {
                            swal({
                                title: "Oops...",
                                text: "Veuillez vérifier votre formulaire!",
                                type: "error",
                                timer: 1500
                            });
                        }
                    });
                }
            },
            {
                content: "<?php echo __d('default', 'Button.cancel'); ?>",
                class: "btn-danger ",
                action: function () {
                    $('#infos').modal('hide');
                }
            }
        ]
    });

    loadTypesSoutypes();

    $(document).ready(function () {
        gui.addbutton({
            element: $('#SoustypeGetSoustypesFormButton'),
            button: {
                content: '<i class="fa fa-search" aria-hidden="true"></i> Rechercher',
                class: 'btn btn-success searchBtn',
                action: function () {
                    var form = $(this).parents('.modal').find('form');
                    gui.request({
                        url: form.attr('action'),
                        data: form.serialize(),
                        loader: true,
                        updateElement: $('#browser .filetree.typestype'),
                        loaderMessage: gui.loaderMessage
                    }, function (data) {
                        $('#browser').empty();
                        $('.content').html(data);
                    });
                    $(this).parents('.modal').modal('hide');

                }

            }
        });
        gui.addbutton({
            element: $('#SoustypeGetSoustypesFormButton'),
            button: {
                content: '<i class="fa fa-undo" aria-hidden="true"></i> Réinitialiser',
                class: 'btn btn-danger cancelSearch ',
                action: function () {
                    $(this).parents('.modal').modal('hide');
                    loadTypesSoutypes();
                }

            }
        });
    });
</script>
<div id="SoustypeGetSoustypesFormModal" class="modal fade" role="dialog">
    <div class="modal-dialog modal-lg">
        <div class="modal-content zone-form">
            <div class="modal-header">
                <h4 class="modal-title">Recherche de type/sous-type</h4>
            </div>
            <div class="modal-body">
                            <?php 
                        $formSoustypeSearch = array(
                            'name' => 'Soustype',
                            'label_w' => 'col-sm-5',
                            'input_w' => 'col-sm-5',
                            'form_url' => 'getTypesSoustypes',
                            'input' => array(
                                'Type.name' => array(
                                    'labelText' => __d('type', 'Type.name'),
                                    'inputType' => 'select',
                                    'items'=>array(
                                        'type' => 'select',
                                        'options' => $listeTypes,
                                        'empty' => true
                                    )
                                ),
                                'Type.active' => array(
                                    'labelText' =>__d('type', 'Type.active'),
                                    'inputType' => 'checkbox',
                                    'items'=>array(
                                        'type'=>'checkbox',
                                        'default' => true, 
                                        'checked' => true,
                                        'required' => false
                                    )
                                )
                            )
                        );
                        echo $this->Formulaire->createForm($formSoustypeSearch);
                        echo $this->Form->end();
                        ?>
            </div>
            <div id="SoustypeGetSoustypesFormButton" class="modal-footer controls " role="group">

            </div>
                        <?php echo $this->Form->end();?>
        </div>
    </div>
</div>
<script type="text/javascript">
    $('#TypeName').select2({allowClear: true, placeholder: "Sélectionner un type"});
</script>